-- German translations courtesy of Amethadan at lotrointerface.com
-- to do
-- need a permanent fix for the unique stack ID bug

-- turbine client imports
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
-- need localPlayer to test for session play
localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
charName=localPlayer:GetName();
charVaultName=charName.." (Vault)";
-- immediately test for session play BEFORE importing any other files so that we can safely bail without loading any data and without any handlers
if string.sub(charName,1,1)=="~" then
	-- do not load if the character is a session play character
	Turbine.Shell.WriteLine("Item Tracker does not support session play characters.");
	return
end

string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

import "GaranStuff.ItemTracker.Class";
import "GaranStuff.ItemTracker.VindarPatch";
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import "GaranStuff.ItemTracker.ColorPicker";
import "GaranStuff.ItemTracker.Strings";
import "GaranStuff.ItemTracker.Table";
import "GaranStuff.ItemTracker.RadioButtonGroup";
import "GaranStuff.ItemTracker.DropDownList";
import "GaranStuff.ItemTracker.DebugWindow";
import "GaranStuff.ItemTracker.FontMetric";

language=1;
euroFormat=(tonumber("1,000")==1);
if euroFormat then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

setupVisible=false;
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state
moveToggle=false;

Settings=PatchDataLoad(Turbine.DataScope.Character, "ItemTrackerSettings");
if Settings==nil then
	Settings={}
end

if Settings.debug==nil then Settings.debug=false end;
Settings.debug=false; -- don't allow persistent debugging (to debug initialization this has to be temporarily commented out)
if Settings.fontColor==nil then
	Settings.fontColor=Turbine.UI.Color(1,.9,.5)
else
	Settings.fontColor=Turbine.UI.Color(euroNormalize(Settings.fontColor.R),euroNormalize(Settings.fontColor.G),euroNormalize(Settings.fontColor.B))
end
if Settings.errorColor==nil then
	Settings.errorColor=Turbine.UI.Color(1,0,0)
else
	Settings.errorColor=Turbine.UI.Color(euroNormalize(Settings.errorColor.R),euroNormalize(Settings.errorColor.G),euroNormalize(Settings.errorColor.B))
end

if Settings.trimColor==nil then
	Settings.trimColor=Turbine.UI.Color(.4,.4,.5)
else
	Settings.trimColor=Turbine.UI.Color(euroNormalize(Settings.trimColor.R),euroNormalize(Settings.trimColor.G),euroNormalize(Settings.trimColor.B))
end
if Settings.backColor==nil then
	Settings.backColor=Turbine.UI.Color(.05,.05,.05)
else
	Settings.backColor=Turbine.UI.Color(euroNormalize(Settings.backColor.R),euroNormalize(Settings.backColor.G),euroNormalize(Settings.backColor.B))
end
if Settings.panelBackColor==nil then
	Settings.panelBackColor=Turbine.UI.Color(.25,.75,.45)
else
	Settings.panelBackColor=Turbine.UI.Color(euroNormalize(Settings.panelBackColor.R),euroNormalize(Settings.panelBackColor.G),euroNormalize(Settings.panelBackColor.B))
end
if Settings.headingsColor==nil then
	Settings.headingsColor=Turbine.UI.Color(1,1,1)
else
	Settings.headingsColor=Turbine.UI.Color(euroNormalize(Settings.headingsColor.R),euroNormalize(Settings.headingsColor.G),euroNormalize(Settings.headingsColor.B))
end
if Settings.listTextColor==nil then
	Settings.listTextColor=Turbine.UI.Color(1,1,1)
else
	Settings.listTextColor=Turbine.UI.Color(euroNormalize(Settings.listTextColor.R),euroNormalize(Settings.listTextColor.G),euroNormalize(Settings.listTextColor.B))
end
if Settings.critColor==nil then
	Settings.critColor=Turbine.UI.Color(.9,0,0)
else
	Settings.critColor=Turbine.UI.Color(euroNormalize(Settings.critColor.R),euroNormalize(Settings.critColor.G),euroNormalize(Settings.critColor.B))
end
if Settings.lowColor==nil then
	Settings.lowColor=Turbine.UI.Color(.8,.5,0)
else
	Settings.lowColor=Turbine.UI.Color(euroNormalize(Settings.lowColor.R),euroNormalize(Settings.lowColor.G),euroNormalize(Settings.lowColor.B))
end
if Settings.highColor==nil then
	Settings.highColor=Turbine.UI.Color(0,.8,0)
else
	Settings.highColor=Turbine.UI.Color(euroNormalize(Settings.highColor.R),euroNormalize(Settings.highColor.G),euroNormalize(Settings.highColor.B))
end

if Settings.fontFace==nil then Settings.fontFace=Turbine.UI.Lotro.Font.Verdana16 end
if Settings.opacity==nil then Settings.opacity=1 end
if Settings.lowQty==nil then Settings.lowQty=10 end
if Settings.critQty==nil then Settings.critQty=5 end
if Settings.highQty==nil then Settings.highQty=100 end
if Settings.lowShow==nil then Settings.lowShow=true end
if Settings.critShow==nil then Settings.critShow=true end
if Settings.normalShow==nil then Settings.normalShow=true end
if Settings.highShow==nil then Settings.highShow=true end
if Settings.showTotals==nil then Settings.showTotals=true end
if Settings.showCurrent==nil then Settings.showCurrent=true end
if Settings.outlineQtyText==nil then Settings.outlineQtyText=true end

listTabTrimColor=Turbine.UI.Color(.5,.5,.8);
listTabBackColor=Turbine.UI.Color(.1,.1,.15);
defaultsTabTrimColor=Turbine.UI.Color(.8,.5,.5);
defaultsTabBackColor=Turbine.UI.Color(.15,.1,.1);
errorColor=Turbine.UI.Color(1,.2,.2);
successColor=Turbine.UI.Color(.2,1,.2);
fontMetric=FontMetric();
fontMetric:SetFont(Settings.fontFace);

-- This is the callback mechanism provided by Pengoros, slightly modified to guarantee uniqueness
function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
	else
		if (type(object[event]) == "table") then
			local exists=false;
			local k,v;
			for k,v in ipairs(object[event]) do
				if v==callback then
					exists=true;
					break;
				end
			end
			if not exists then
				table.insert(object[event], callback);
			end
		else
			if object[event]~=callback then
				object[event] = {object[event], callback};
			end
		end
	end
	return callback;
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

function UnloadPlugin()
	SaveData();

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	if setupWindow~=nil then
		Turbine.Shell.RemoveCommand(setupWindow.shellCmd)
	end

	-- safely remove all callbacks
	local index;
	for index=1,backPack:GetSize() do
		if backpackImage[index]~=nil and backpackImage[index].Item~=nil then
			if backpackImage[index].Item.QuantityChanged~=nil then
				RemoveCallback(backpackImage[index].Item,"QuantityChanged",quantityChanged)
			end
		end
	end
	for index=1,#sharedStorageImage do
		if sharedStorageImage[index].Item~=nil then
			if sharedStorageImage[index].Item.QuantityChanged~=nil then
				RemoveCallback(sharedStorageImage[index].Item,"QuantityChanged",sharedStorageQuantityChanged)
			end
		end
	end
	for index=1,#vaultImage do
		if vaultImage[index].Item~=nil then
			if vaultImage[index].Item.QuantityChanged~=nil then
				RemoveCallback(vaultImage[index].Item,"QuantityChanged",vaultQuantityChanged)
			end
		end
	end

	RemoveCallback(backPack,"ItemAdded",itemAdded)
	RemoveCallback(backPack,"ItemRemoved",itemRemoved)
	RemoveCallback(backPack,"ItemMoved",itemMoved)
	RemoveCallback(sharedStorage,"ItemAdded",sharedStorageItemAdded);
	RemoveCallback(sharedStorage,"ItemRemoved",sharedStorageItemRemoved);
	RemoveCallback(sharedStorage,"IsAvailableChanged",refreshSharedStorage);
	RemoveCallback(sharedStorage,"ItemsRefreshed",refreshSharedStorage);
	RemoveCallback(vault,"ItemAdded",vaultItemAdded);
	RemoveCallback(vault,"ItemRemoved",vaultItemRemoved);
	RemoveCallback(vault,"IsAvailableChanged",refreshVault);
	RemoveCallback(vault,"ItemsRefreshed",refreshVault);
end
function SaveData()

	-- save the tooltip settings
	local tmpIndex;
	Settings.version=Plugins.ItemTracker:GetVersion();
	Settings.SWTop=setupWindow:GetTop();
	Settings.SWLeft=setupWindow:GetLeft();
	PatchDataSave(Turbine.DataScope.Character, "ItemTrackerSettings", Settings);
	-- now save the tracked item data
	local TrackedItemData={}
	for k,v in ipairs(trackWindows) do
		TrackedItemData[k]={};
		TrackedItemData[k].Name=v.Name;
		TrackedItemData[k].Top=v:GetTop();
		TrackedItemData[k].Left=v.GetLeft();
		TrackedItemData[k].ShowTotals=v.ItemList.ShowTotals;
		TrackedItemData[k].ShowCurrent=v.ItemList.ShowCurrent;
		TrackedItemData[k].Items={};
		for i=1,v.ItemList:GetItemCount() do
			local item=v.ItemList:GetItem(i);
			if item.Icon~=nil and item.Icon.ItemCode~=nil then
				local newIndex=#TrackedItemData[k].Items+1;
				TrackedItemData[k].Items[newIndex]={};
				TrackedItemData[k].Items[newIndex].ItemCode=item.Icon.ItemCode;
				TrackedItemData[k].Items[newIndex].Crit=item.Crit;
				TrackedItemData[k].Items[newIndex].CritShow=item.CritShow;
				TrackedItemData[k].Items[newIndex].Low=item.Low;
				TrackedItemData[k].Items[newIndex].LowShow=item.LowShow;
				TrackedItemData[k].Items[newIndex].NormalShow=item.NormalShow;
				TrackedItemData[k].Items[newIndex].High=item.High;
				TrackedItemData[k].Items[newIndex].HighShow=item.HighShow;
			end
		end
	end
	PatchDataSave(Turbine.DataScope.Character, "ItemTrackerData", TrackedItemData);
	if accountItemQty==nil then accountItemQty={} end
	local index;
	for index=1,backPack:GetSize() do
		local item=backPack:GetItem(index);
		if item~=nil then
			local name=item:GetItemInfo():GetName();
			if accountItemQty[name]==nil then
				accountItemQty[name]={}
				accountItemQty[name].Total=0;
			end
			if accountItemQty[name][charName]==nil then
				accountItemQty[name][charName]=item:GetQuantity();
			else
				accountItemQty[name][charName]=accountItemQty[name][charName]+item:GetQuantity();
			end
			accountItemQty[name].Total=accountItemQty[name].Total+item:GetQuantity();
		end
	end
	PatchDataSave(Turbine.DataScope.Server, "ItemTrackerData", accountItemQty);
end

setupWindow = Turbine.UI.Lotro.Window();
setupWindow.Loaded=false;

local initHeight=610;
local initWidth=445;
if Settings.SWTop==nil then Settings.SWTop=(Turbine.UI.Display:GetHeight() - initHeight) / 2 end
if Settings.SWLeft==nil then Settings.SWLeft=(Turbine.UI.Display:GetWidth() - initWidth) / 2 end

if initHeight>Turbine.UI.Display:GetHeight() then initHeight=Turbine.UI.Display:GetHeight() end
if initHeight+Settings.SWTop>Turbine.UI.Display:GetHeight() then Settings.SWTop=Turbine.UI.Display:GetHeight()-initHeight end
if initWidth>Turbine.UI.Display:GetWidth() then initWidth=Turbine.UI.Display:GetWidth() end
if initWidth+Settings.SWLeft>Turbine.UI.Display:GetWidth() then Settings.SWLeft=Turbine.UI.Display:GetWidth()-initWidth end

setupWindow:SetPosition( Settings.SWLeft, Settings.SWTop );
setupWindow:SetHeight(initHeight);
setupWindow:SetWidth(initWidth);
setupWindow:SetOpacity(Settings.opacity);
setupWindow:SetVisible(false);

setupWindow.TabBack=Turbine.UI.Label();
setupWindow.TabBack:SetParent(setupWindow);
setupWindow.TabBack:SetSize(setupWindow:GetWidth()-20,setupWindow:GetHeight()-100);
setupWindow.TabBack:SetPosition(10,65);
setupWindow.TabBack:SetBackColor(listTabTrimColor);

-- list tab
setupWindow.ListTab=Turbine.UI.Label();
setupWindow.ListTab:SetParent(setupWindow.TabBack);
setupWindow.ListTab:SetPosition(1,1);
setupWindow.ListTab:SetSize(setupWindow.TabBack:GetWidth()-2,setupWindow.TabBack:GetHeight()-2);
setupWindow.ListTab:SetBackColor(listTabBackColor);
setupWindow.ListSelCaption=Turbine.UI.Label();
setupWindow.ListSelCaption:SetParent(setupWindow.ListTab);
setupWindow.ListSelCaption:SetSize(100,20);
setupWindow.ListSelCaption:SetPosition(5,5);
setupWindow.ListSelCaption:SetFont(Settings.fontFace);
setupWindow.ListSelCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.ListSelCaption:SetText(Resource[language][4]..":");
setupWindow.ListSel=DropDownList();
setupWindow.ListSel:SetParent(setupWindow.ListTab);
setupWindow.ListSel:SetPosition(setupWindow.ListSelCaption:GetLeft()+setupWindow.ListSelCaption:GetWidth()+5,setupWindow.ListSelCaption:GetTop());
setupWindow.ListSel:SetSize(setupWindow.ListTab:GetWidth()-setupWindow.ListSel:GetLeft()-10,20);
setupWindow.ListSel:SetBackColor(Settings.backColor);
setupWindow.ListSel:SetCurrentBackColor(Settings.backColor);
setupWindow.ListSel:SetBorderColor(Settings.trimColor);
setupWindow.GroupBorder=Turbine.UI.Control();
setupWindow.GroupBorder:SetParent(setupWindow.ListTab);
setupWindow.GroupBorder:SetPosition(10,setupWindow.ListSelCaption:GetTop()+setupWindow.ListSelCaption:GetHeight()+5)
setupWindow.GroupBorder:SetSize(setupWindow.ListTab:GetWidth()-20,setupWindow.ListTab:GetHeight()-10-setupWindow.GroupBorder:GetTop());
setupWindow.GroupBorder:SetBackColor(Settings.trimColor);
setupWindow.GroupPanel=Turbine.UI.Control();
setupWindow.GroupPanel:SetParent(setupWindow.GroupBorder);
setupWindow.GroupPanel:SetPosition(1,1);
setupWindow.GroupPanel:SetSize(setupWindow.GroupBorder:GetWidth()-2,setupWindow.GroupBorder:GetHeight()-2);
setupWindow.GroupPanel:SetBackColor(Settings.backColor);
setupWindow.GroupCaption=Turbine.UI.Label();
setupWindow.GroupCaption:SetParent(setupWindow.GroupPanel);
setupWindow.GroupCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.GroupCaption:SetPosition(5,5);
setupWindow.GroupCaption:SetFont(Settings.fontFace);
setupWindow.GroupCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.GroupCaption:SetText(Resource[language][5]..":");
setupWindow.GroupValue=Turbine.UI.Lotro.TextBox();
setupWindow.GroupValue:SetParent(setupWindow.GroupPanel);
setupWindow.GroupValue:SetPosition(setupWindow.ListSel:GetLeft(),setupWindow.GroupCaption:GetTop());
setupWindow.GroupValue:SetSize(setupWindow.GroupPanel:GetWidth()-setupWindow.GroupValue:GetLeft()-15,20)
setupWindow.GroupValue:SetFont(Settings.fontFace);
setupWindow.LeftCaption=Turbine.UI.Label();
setupWindow.LeftCaption:SetParent(setupWindow.GroupPanel);
setupWindow.LeftCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.LeftCaption:SetPosition(setupWindow.GroupCaption:GetLeft(),setupWindow.GroupCaption:GetTop()+setupWindow.GroupCaption:GetHeight()+5);
setupWindow.LeftCaption:SetFont(Settings.fontFace);
setupWindow.LeftCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.LeftCaption:SetText(Resource[language][6]..":");
setupWindow.LeftValue=Turbine.UI.Lotro.TextBox();
setupWindow.LeftValue:SetParent(setupWindow.GroupPanel);
setupWindow.LeftValue:SetSize(setupWindow.GroupValue:GetWidth(),20)
setupWindow.LeftValue:SetPosition(setupWindow.GroupValue:GetLeft(),setupWindow.LeftCaption:GetTop());
setupWindow.LeftValue:SetFont(Settings.fontFace);
setupWindow.TopCaption=Turbine.UI.Label();
setupWindow.TopCaption:SetParent(setupWindow.GroupPanel);
setupWindow.TopCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.TopCaption:SetPosition(setupWindow.GroupCaption:GetLeft(),setupWindow.LeftCaption:GetTop()+setupWindow.LeftCaption:GetHeight()+5);
setupWindow.TopCaption:SetFont(Settings.fontFace);
setupWindow.TopCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.TopCaption:SetText(Resource[language][7]..":");
setupWindow.TopValue=Turbine.UI.Lotro.TextBox();
setupWindow.TopValue:SetParent(setupWindow.GroupPanel);
setupWindow.TopValue:SetSize(setupWindow.GroupValue:GetWidth(),20)
setupWindow.TopValue:SetPosition(setupWindow.GroupValue:GetLeft(),setupWindow.TopCaption:GetTop());
setupWindow.TopValue:SetFont(Settings.fontFace);
setupWindow.TotalsCaption=Turbine.UI.Label();
setupWindow.TotalsCaption:SetParent(setupWindow.GroupPanel);
setupWindow.TotalsCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.TotalsCaption:SetPosition(setupWindow.GroupCaption:GetLeft(),setupWindow.TopCaption:GetTop()+setupWindow.TopCaption:GetHeight()+5);
setupWindow.TotalsCaption:SetFont(Settings.fontFace);
setupWindow.TotalsCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.TotalsCaption:SetText(Resource[language][30]..":");
setupWindow.ShowTotals=RadioButtonGroup();
setupWindow.ShowTotals:SetParent(setupWindow.GroupPanel);
setupWindow.ShowTotals:SetFont(Settings.fontFace);
setupWindow.ShowTotals:SetSize(setupWindow.TopValue:GetWidth(),20)
setupWindow.ShowTotals:SetPosition(setupWindow.TopValue:GetLeft(),setupWindow.TotalsCaption:GetTop());
setupWindow.ShowTotals.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.ShowTotals.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.ShowTotals.IconWidth=16;
setupWindow.ShowTotals.IconHeight=16;
setupWindow.ShowTotals:SetBorderColor(nil);
setupWindow.ShowTotals:SetBackColor(nil);
setupWindow.ShowTotals:AddChoice(Resource[language][19],true);
setupWindow.ShowTotals:AddChoice(Resource[language][20],false);
setupWindow.ShowTotals:AddChoice(Resource[language][21],nil);
setupWindow.ShowTotals:SetSelectedChoice(3);

setupWindow.CurrentCaption=Turbine.UI.Label();
setupWindow.CurrentCaption:SetParent(setupWindow.GroupPanel);
setupWindow.CurrentCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.CurrentCaption:SetPosition(setupWindow.GroupCaption:GetLeft(),setupWindow.TotalsCaption:GetTop()+setupWindow.TotalsCaption:GetHeight()+5);
setupWindow.CurrentCaption:SetFont(Settings.fontFace);
setupWindow.CurrentCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.CurrentCaption:SetText(Resource[language][31]..":");
setupWindow.ShowCurrent=RadioButtonGroup();
setupWindow.ShowCurrent:SetParent(setupWindow.GroupPanel);
setupWindow.ShowCurrent:SetFont(Settings.fontFace);
setupWindow.ShowCurrent:SetSize(setupWindow.TopValue:GetWidth(),20)
setupWindow.ShowCurrent:SetPosition(setupWindow.TopValue:GetLeft(),setupWindow.CurrentCaption:GetTop());
setupWindow.ShowCurrent.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.ShowCurrent.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.ShowCurrent.IconWidth=16;
setupWindow.ShowCurrent.IconHeight=16;
setupWindow.ShowCurrent:SetBorderColor(nil);
setupWindow.ShowCurrent:SetBackColor(nil);
setupWindow.ShowCurrent:AddChoice(Resource[language][19],true);
setupWindow.ShowCurrent:AddChoice(Resource[language][20],false);
setupWindow.ShowCurrent:AddChoice(Resource[language][21],nil);
setupWindow.ShowCurrent:SetSelectedChoice(3);

setupWindow.ItemSelCaption=Turbine.UI.Label();
setupWindow.ItemSelCaption:SetParent(setupWindow.GroupPanel);
setupWindow.ItemSelCaption:SetSize(100,20);
setupWindow.ItemSelCaption:SetPosition(setupWindow.GroupCaption:GetLeft(),setupWindow.CurrentCaption:GetTop()+setupWindow.CurrentCaption:GetHeight()+15);
setupWindow.ItemSelCaption:SetFont(Settings.fontFace);
setupWindow.ItemSelCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.ItemSelCaption:SetText(Resource[language][8]..":");
setupWindow.ItemSelCaption:SetVisible(false);
setupWindow.ItemSel=DropDownList();
setupWindow.ItemSel:SetParent(setupWindow.GroupPanel);
setupWindow.ItemSel:SetPosition(setupWindow.GroupValue:GetLeft(),setupWindow.ItemSelCaption:GetTop());
setupWindow.ItemSel:SetSize(setupWindow.GroupValue:GetWidth(),20);
setupWindow.ItemSel:SetBackColor(Settings.backColor);
setupWindow.ItemSel:SetCurrentBackColor(Settings.backColor);
setupWindow.ItemSel:SetBorderColor(Settings.trimColor);

setupWindow.ItemBorder=Turbine.UI.Control();
setupWindow.ItemBorder:SetParent(setupWindow.GroupPanel);
setupWindow.ItemBorder:SetPosition(15,setupWindow.ItemSelCaption:GetTop()+setupWindow.ItemSelCaption:GetHeight()+5)
setupWindow.ItemBorder:SetSize(setupWindow.GroupPanel:GetWidth()-30,setupWindow.GroupPanel:GetHeight()-30-setupWindow.ItemBorder:GetTop());
setupWindow.ItemBorder:SetBackColor(Settings.trimColor);
setupWindow.ItemPanel=Turbine.UI.Control();
setupWindow.ItemPanel:SetParent(setupWindow.ItemBorder);
setupWindow.ItemPanel:SetPosition(1,1)
setupWindow.ItemPanel:SetSize(setupWindow.ItemBorder:GetWidth()-2,setupWindow.ItemBorder:GetHeight()-2);
setupWindow.ItemPanel:SetBackColor(Settings.backColor);

setupWindow.IconBack=Turbine.UI.Control();
setupWindow.IconBack:SetParent(setupWindow.ItemPanel);
setupWindow.IconBack:SetSize(35,35);
setupWindow.IconBack:SetPosition(setupWindow.ListSelCaption:GetLeft()+setupWindow.ListSelCaption:GetWidth()-setupWindow.IconBack:GetWidth(),5);
setupWindow.IconBack:SetBackColor(Settings.trimColor);
setupWindow.Icon=Turbine.UI.Lotro.ItemInfoControl();
setupWindow.Icon:SetParent(setupWindow.IconBack);
setupWindow.Icon:SetSize(34,34);
setupWindow.Icon:SetPosition(-1,-1);
setupWindow.Icon:SetAllowDrop(true)
setupWindow.IconName=Turbine.UI.Label();
setupWindow.IconName:SetParent(setupWindow.ItemPanel);
setupWindow.IconName:SetPosition(setupWindow.IconBack:GetLeft()+setupWindow.IconBack:GetWidth()+5,setupWindow.IconBack:GetTop());
setupWindow.IconName:SetSize(setupWindow:GetWidth()-setupWindow.IconName:GetLeft()-20,35);
setupWindow.IconName:SetFont(Settings.fontFace);
setupWindow.IconName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
setupWindow.IconName:SetText(Resource[language][15]);
setupWindow.ThresholdsCaption=Turbine.UI.Label();
setupWindow.ThresholdsCaption:SetParent(setupWindow.ItemPanel);
setupWindow.ThresholdsCaption:SetSize(setupWindow.ItemPanel:GetWidth()-30,20);
setupWindow.ThresholdsCaption:SetPosition(15,setupWindow.IconBack:GetTop()+setupWindow.IconBack:GetHeight()+5);
setupWindow.ThresholdsCaption:SetFont(Settings.fontFace);
setupWindow.ThresholdsCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
setupWindow.ThresholdsCaption:SetText(Resource[language][9]);
setupWindow.CritCaption=Turbine.UI.Label();
setupWindow.CritCaption:SetParent(setupWindow.ItemPanel);
setupWindow.CritCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.CritCaption:SetPosition(setupWindow.ListSelCaption:GetLeft(),setupWindow.ThresholdsCaption:GetTop()+setupWindow.ThresholdsCaption:GetHeight()+5);
setupWindow.CritCaption:SetFont(Settings.fontFace);
setupWindow.CritCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.CritCaption:SetText(Resource[language][10]..":");
setupWindow.CritValue=Turbine.UI.Lotro.TextBox();
setupWindow.CritValue:SetParent(setupWindow.ItemPanel);
setupWindow.CritValue:SetPosition(setupWindow.CritCaption:GetLeft()+setupWindow.CritCaption:GetWidth()+5,setupWindow.CritCaption:GetTop());
setupWindow.CritValue:SetSize(80,20)
setupWindow.CritValue:SetFont(Settings.fontFace);
setupWindow.CritUseDefault=Turbine.UI.Label();
setupWindow.CritUseDefault:SetParent(setupWindow.ItemPanel);
setupWindow.CritUseDefault:SetPosition(setupWindow.CritValue:GetLeft()+setupWindow.CritValue:GetWidth()+5,setupWindow.CritValue:GetTop())
setupWindow.CritUseDefault:SetSize(setupWindow.ItemPanel:GetWidth()-setupWindow.CritUseDefault:GetLeft()-30,20);
setupWindow.CritUseDefault:SetFont(Settings.fontFace);
setupWindow.CritUseDefault:SetText(Resource[language][13]);
setupWindow.CritShow=RadioButtonGroup();
setupWindow.CritShow:SetParent(setupWindow.ItemPanel);
setupWindow.CritShow:SetPosition(setupWindow.CritValue:GetLeft(),setupWindow.CritValue:GetTop()+setupWindow.CritValue:GetHeight())
setupWindow.CritShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.CritShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.CritShow.IconWidth=16;
setupWindow.CritShow.IconHeight=16;
setupWindow.CritShow:SetBorderColor(Settings.backColor);
setupWindow.CritShow:SetBackColor(Settings.backColor);
setupWindow.CritShow:SetSize(setupWindow.ItemPanel:GetWidth()-setupWindow.CritShow:GetLeft()-30,18);
setupWindow.CritShow:AddChoice(Resource[language][19],true);
setupWindow.CritShow:AddChoice(Resource[language][20],false);
setupWindow.CritShow:AddChoice(Resource[language][21],nil);
setupWindow.CritShow:SetSelectedChoice(3);
setupWindow.Sep1=Turbine.UI.Control();
setupWindow.Sep1:SetParent(setupWindow.ItemPanel);
setupWindow.Sep1:SetSize(setupWindow.ItemPanel:GetWidth()-30,1);
setupWindow.Sep1:SetPosition(15,setupWindow.CritShow:GetTop()+setupWindow.CritShow:GetHeight()+4);
setupWindow.Sep1:SetBackColor(Settings.trimColor);
setupWindow.LowCaption=Turbine.UI.Label();
setupWindow.LowCaption:SetParent(setupWindow.ItemPanel);
setupWindow.LowCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.LowCaption:SetPosition(setupWindow.CritCaption:GetLeft(),setupWindow.Sep1:GetTop()+setupWindow.Sep1:GetHeight()+4);
setupWindow.LowCaption:SetFont(Settings.fontFace);
setupWindow.LowCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.LowCaption:SetText(Resource[language][11]..":");
setupWindow.LowValue=Turbine.UI.Lotro.TextBox();
setupWindow.LowValue:SetParent(setupWindow.ItemPanel);
setupWindow.LowValue:SetPosition(setupWindow.ListSel:GetLeft(),setupWindow.LowCaption:GetTop());
setupWindow.LowValue:SetSize(80,20)
setupWindow.LowValue:SetFont(Settings.fontFace);
setupWindow.LowUseDefault=Turbine.UI.Label();
setupWindow.LowUseDefault:SetParent(setupWindow.ItemPanel);
setupWindow.LowUseDefault:SetPosition(setupWindow.LowValue:GetLeft()+setupWindow.LowValue:GetWidth()+5,setupWindow.LowValue:GetTop())
setupWindow.LowUseDefault:SetSize(setupWindow.ItemPanel:GetWidth()-setupWindow.CritUseDefault:GetLeft()-30,20);
setupWindow.LowUseDefault:SetFont(Settings.fontFace);
setupWindow.LowUseDefault:SetText(Resource[language][13]);
setupWindow.LowShow=RadioButtonGroup();
setupWindow.LowShow:SetParent(setupWindow.ItemPanel);
setupWindow.LowShow:SetPosition(setupWindow.LowValue:GetLeft(),setupWindow.LowValue:GetTop()+setupWindow.LowValue:GetHeight())
setupWindow.LowShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.LowShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.LowShow.IconWidth=16;
setupWindow.LowShow.IconHeight=16;
setupWindow.LowShow:SetBorderColor(Settings.backColor);
setupWindow.LowShow:SetBackColor(Settings.backColor);
setupWindow.LowShow:SetSize(setupWindow.ItemPanel:GetWidth()-setupWindow.LowShow:GetLeft()-30,18);
setupWindow.LowShow:AddChoice(Resource[language][19],true);
setupWindow.LowShow:AddChoice(Resource[language][20],false);
setupWindow.LowShow:AddChoice(Resource[language][21],nil);
setupWindow.LowShow:SetSelectedChoice(3);
setupWindow.Sep2=Turbine.UI.Control();
setupWindow.Sep2:SetParent(setupWindow.ItemPanel);
setupWindow.Sep2:SetSize(setupWindow.ItemPanel:GetWidth()-30,1);
setupWindow.Sep2:SetPosition(15,setupWindow.LowShow:GetTop()+setupWindow.LowShow:GetHeight()+4);
setupWindow.Sep2:SetBackColor(Settings.trimColor);

setupWindow.NormalCaption=Turbine.UI.Label();
setupWindow.NormalCaption:SetParent(setupWindow.ItemPanel);
setupWindow.NormalCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.NormalCaption:SetPosition(setupWindow.LowCaption:GetLeft(),setupWindow.Sep2:GetTop()+setupWindow.Sep2:GetHeight()+4);
setupWindow.NormalCaption:SetFont(Settings.fontFace);
setupWindow.NormalCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.NormalCaption:SetText(Resource[language][22]..":");
setupWindow.NormalShow=RadioButtonGroup();
setupWindow.NormalShow:SetParent(setupWindow.ItemPanel);
setupWindow.NormalShow:SetPosition(setupWindow.CritShow:GetLeft(),setupWindow.NormalCaption:GetTop())
setupWindow.NormalShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.NormalShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.NormalShow.IconWidth=16;
setupWindow.NormalShow.IconHeight=16;
setupWindow.NormalShow:SetBorderColor(Settings.backColor);
setupWindow.NormalShow:SetBackColor(Settings.backColor);
setupWindow.NormalShow:SetSize(setupWindow.ItemPanel:GetWidth()-setupWindow.NormalShow:GetLeft()-30,18);
setupWindow.NormalShow:AddChoice(Resource[language][19],true);
setupWindow.NormalShow:AddChoice(Resource[language][20],false);
setupWindow.NormalShow:AddChoice(Resource[language][21],nil);
setupWindow.NormalShow:SetSelectedChoice(3);
setupWindow.Sep3=Turbine.UI.Control();
setupWindow.Sep3:SetParent(setupWindow.ItemPanel);
setupWindow.Sep3:SetSize(setupWindow.ItemPanel:GetWidth()-30,1);
setupWindow.Sep3:SetPosition(15,setupWindow.NormalShow:GetTop()+setupWindow.NormalShow:GetHeight()+4);
setupWindow.Sep3:SetBackColor(Settings.trimColor);

setupWindow.HighCaption=Turbine.UI.Label();
setupWindow.HighCaption:SetParent(setupWindow.ItemPanel);
setupWindow.HighCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.HighCaption:SetPosition(setupWindow.LowCaption:GetLeft(),setupWindow.Sep3:GetTop()+setupWindow.Sep3:GetHeight()+4);
setupWindow.HighCaption:SetFont(Settings.fontFace);
setupWindow.HighCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.HighCaption:SetText(Resource[language][12]..":");
setupWindow.HighValue=Turbine.UI.Lotro.TextBox();
setupWindow.HighValue:SetParent(setupWindow.ItemPanel);
setupWindow.HighValue:SetPosition(setupWindow.ListSel:GetLeft(),setupWindow.HighCaption:GetTop());
setupWindow.HighValue:SetSize(80,20)
setupWindow.HighValue:SetFont(Settings.fontFace);
setupWindow.HighUseDefault=Turbine.UI.Label();
setupWindow.HighUseDefault:SetParent(setupWindow.ItemPanel);
setupWindow.HighUseDefault:SetPosition(setupWindow.HighValue:GetLeft()+setupWindow.HighValue:GetWidth()+5,setupWindow.HighValue:GetTop())
setupWindow.HighUseDefault:SetSize(setupWindow.ItemPanel:GetWidth()-setupWindow.HighUseDefault:GetLeft()-30,20);
setupWindow.HighUseDefault:SetText(Resource[language][13]);
setupWindow.HighUseDefault:SetFont(Settings.fontFace);
setupWindow.HighShow=RadioButtonGroup();
setupWindow.HighShow:SetParent(setupWindow.ItemPanel);
setupWindow.HighShow:SetPosition(setupWindow.HighValue:GetLeft(),setupWindow.HighValue:GetTop()+setupWindow.HighValue:GetHeight())
setupWindow.HighShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.HighShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.HighShow.IconWidth=16;
setupWindow.HighShow.IconHeight=16;
setupWindow.HighShow:SetBorderColor(Settings.backColor);
setupWindow.HighShow:SetBackColor(Settings.backColor);
setupWindow.HighShow:SetSize(setupWindow.ItemPanel:GetWidth()-setupWindow.HighShow:GetLeft()-30,18);
setupWindow.HighShow:AddChoice(Resource[language][19],true);
setupWindow.HighShow:AddChoice(Resource[language][20],false);
setupWindow.HighShow:AddChoice(Resource[language][21],nil);
setupWindow.HighShow:SetSelectedChoice(3);
setupWindow.Icon.DragDrop=function(sender,args)
	setupWindow.Icon.Type=nil;
	setupWindow.Icon.Data=nil;
	local shortcut = args.DragDropInfo:GetShortcut();
	if ( shortcut ~= nil ) then
		if shortcut:GetType()==2 then
			setupWindow.Icon.Type=shortcut:GetType();
			local data=shortcut:GetData();
			-- need to strip off unique stack id
			local pos1=string.find (data,",",0,true);
			local data2=string.sub(data,pos1+1);
			if tonumber(data2)==0 then
				-- this is a unique item instance and can not be tracked :(
				data2=data;
-- this requires special handling since unique item stacks IDs will not be valid after the client exits
setupWindow.Message:SetForeColor(Turbine.UI.Color(1,0,0))
setupWindow.Message:SetText("Unique items can not be tracked at this time")
			else
				data2="0x0,"..data2
				setupWindow.Icon.Data=data;
				setupWindow.Icon:SetItemInfo(shortcut:GetItem():GetItemInfo());
				setupWindow.IconName:SetText(shortcut:GetItem():GetItemInfo():GetName())
				setupWindow.SaveItem:SetEnabled(true);
			end
		end
	end
end
setupWindow.SaveItem=Turbine.UI.Lotro.Button();
setupWindow.SaveItem:SetParent(setupWindow.ItemPanel);
setupWindow.SaveItem:SetFont(Settings.fontFace);
setupWindow.SaveItem:SetSize(120,18);
setupWindow.SaveItem:SetPosition(15,setupWindow.ItemPanel:GetHeight()-25);
setupWindow.SaveItem:SetText(Resource[language][26]);
setupWindow.SaveItem.Click=function()
	local name=setupWindow.Icon:GetItemInfo():GetName();
	local index=setupWindow.ListSel:GetValue();
	local itemIndex=setupWindow.ItemSel:GetValue();
	local entry=trackEntry[name];
	local removeName
	if itemIndex~=0 and name~=setupWindow.ItemSel:GetText() then
		--the user has switched items, we need to remove the tracking info for the old item
		removeName=setupWindow.ItemSel:GetText();
	end
	if entry~=nil and (entry.Group~=index or entry.Index~=itemIndex ) then
		setupWindow.Message:SetForeColor(errorColor)
		setupWindow.Message:SetText(Resource[language][35])
	else
		if index==nil or index==0 then
			-- should not be possible
			setupWindow.Message:SetForeColor(errorColor)
			setupWindow.Message:SetText(Resource[language][36])
		else
			if removeName~=nil then
				entry=trackEntry[removeName];
				trackEntry[removeName]=nil;
				entry:SetItem(setupWindow.Icon.Data);
				setupWindow.ItemSel.ListData:GetItem(setupWindow.ItemSel:GetSelectedIndex()):SetText(name);
				setupWindow.ItemSel.CurrentValue:SetText(name);
			end
			local newIndex
			if itemIndex==0 then
				-- add a new entry
				newIndex=trackWindows[index].ItemList:GetItemCount()+1;
				entry=ItemEntry();
				entry:SetItem(setupWindow.Icon.Data);
				entry:SetParent(trackWindows[index].ItemList);
				entry.Group=index;
				trackWindows[index].ItemList:AddItem(entry);
				entry.Index=trackWindows[index].ItemList:GetItemCount();
				setupWindow.ItemSel:AddItem(name,newIndex);
			end
			entry:SetThresholds(tonumber(setupWindow.CritValue:GetText()),setupWindow.CritShow:GetValue(),tonumber(setupWindow.LowValue:GetText()),setupWindow.LowShow:GetValue(),setupWindow.NormalShow:GetValue(),tonumber(setupWindow.HighValue:GetText()),setupWindow.HighShow:GetValue());
			updateQuantity(name);
			if itemIndex==0 then
				setupWindow.ItemSel:SetSelectedIndex(newIndex+1);
			end
			setupWindow.DeleteItem:SetEnabled(true);
			setupWindow.Message:SetForeColor(successColor)
			setupWindow.Message:SetText(Resource[language][37])
		end
	end
end

setupWindow.DeleteItem=Turbine.UI.Lotro.Button();
setupWindow.DeleteItem:SetParent(setupWindow.ItemPanel);
setupWindow.DeleteItem:SetFont(Settings.fontFace);
setupWindow.DeleteItem:SetSize(120,18);
setupWindow.DeleteItem:SetPosition(setupWindow.ItemPanel:GetWidth()-15-setupWindow.DeleteItem:GetWidth(),setupWindow.ItemPanel:GetHeight()-25);
setupWindow.DeleteItem:SetText(Resource[language][27]);
setupWindow.DeleteItem:SetEnabled(false);
setupWindow.DeleteItem.Click=function()
	local name=setupWindow.ItemSel:GetText();
	local windowIndex=setupWindow.ListSel:GetValue();
	local itemWindowIndex=setupWindow.ItemSel:GetValue();
	local itemSelectedIndex=setupWindow.ItemSel:GetSelectedIndex();
	local entry=trackEntry[name];
	local tmpIndex,tmpItem
	-- remove the window entry, decrement the .Index of all entries after the selected entry
	for tmpIndex=1,trackWindows[windowIndex].ItemList:GetItemCount() do
		local tmpItem=trackWindows[windowIndex].ItemList:GetItem(tmpIndex);
		if tmpItem.Index>itemWindowIndex then tmpItem.Index=tmpItem.Index-1 end
	end
	trackEntry[name]:SetVisible(false);
	trackWindows[windowIndex].ItemList:RemoveItemAt(itemWindowIndex);
	trackEntry[name]=nil;

	-- remove entry from selection list, need to decrement the item index of all entries after the selected entry
	for tmpIndex=itemSelectedIndex,setupWindow.ItemSel.ListData:GetItemCount() do
		local tmpItem=setupWindow.ItemSel.ListData:GetItem(tmpIndex);
		tmpItem.DataValue=tmpItem.DataValue-1;
	end
	setupWindow.ItemSel:RemoveItemAt(itemSelectedIndex);
	setupWindow.Message:SetForeColor(successColor)
	setupWindow.Message:SetText(Resource[language][38])
end

setupWindow.SaveGroup=Turbine.UI.Lotro.Button();
setupWindow.SaveGroup:SetParent(setupWindow.GroupPanel);
setupWindow.SaveGroup:SetFont(Settings.fontFace);
setupWindow.SaveGroup:SetSize(120,18);
setupWindow.SaveGroup:SetPosition(15,setupWindow.GroupPanel:GetHeight()-25);
setupWindow.SaveGroup:SetText(Resource[language][24]);
setupWindow.SaveGroup.Click=function()
	local name=string.trim(setupWindow.GroupValue:GetText());
	local windowIndex=setupWindow.ListSel:GetValue();
	if name=="" then
		setupWindow.Message:SetForeColor(errorColor)
		setupWindow.Message:SetText(Resource[language][39])
	else
		local index;
		local found=false;
		for index=2,setupWindow.ListSel.ListData:GetItemCount() do
			if setupWindow.ListSel.ListData:GetItem(index):GetText()==name and (windowIndex==0 or windowIndex~=index-1) then
				found=true;
				break;
			end
		end
		if found then
			setupWindow.Message:SetForeColor(errorColor)
			setupWindow.Message:SetText(Resource[language][40])
		else
			if windowIndex==0 then
				-- create a new entry
				windowIndex=#trackWindows+1
				trackWindows[windowIndex]=TrackWindow();
				trackWindows[windowIndex].Index=windowIndex;
				setupWindow.ListSel:AddItem(name,windowIndex);
			else
				setupWindow.ListSel.ListData:GetItem(setupWindow.ListSel:GetSelectedIndex()):SetText(name);
				setupWindow.ListSel.CurrentValue:SetText(name);
			end
			local top=tonumber(setupWindow.TopValue:GetText());
			if top==nil then top=0 end
			local left=tonumber(setupWindow.LeftValue:GetText());
			if left==nil then left=0 end
			trackWindows[windowIndex].Name=name;
			trackWindows[windowIndex]:SetLeft(left);
			trackWindows[windowIndex]:SetTop(top);
			trackWindows[windowIndex].ItemList.ShowTotals=setupWindow.ShowTotals:GetValue();
			trackWindows[windowIndex].ItemList.ShowCurrent=setupWindow.ShowCurrent:GetValue();

			if setupWindow.ItemSel:GetSelectedIndex()>0 then
--				setupWindow.SaveItem.Click(); -- save the item just in case user forgot to
			end
			if setupWindow.ListSel:GetSelectedIndex()==1 then
				setupWindow.ListSel:SetSelectedIndex(windowIndex+1);
				setupWindow.ListSel.SelectedIndexChanged();
			end
			-- need to call .Layout on all items
			for index=1,trackWindows[windowIndex].ItemList:GetItemCount() do
				trackWindows[windowIndex].ItemList:GetItem(index):Layout();
			end
			setupWindow.Message:SetForeColor(successColor)
			setupWindow.Message:SetText(Resource[language][41])
		end
	end
end
setupWindow.DeleteGroup=Turbine.UI.Lotro.Button();
setupWindow.DeleteGroup:SetParent(setupWindow.GroupPanel);
setupWindow.DeleteGroup:SetFont(Settings.fontFace);
setupWindow.DeleteGroup:SetSize(120,18);
setupWindow.DeleteGroup:SetPosition(setupWindow.GroupPanel:GetWidth()-15-setupWindow.DeleteGroup:GetWidth(),setupWindow.GroupPanel:GetHeight()-25);
setupWindow.DeleteGroup:SetText(Resource[language][25]);
setupWindow.DeleteGroup:SetEnabled(false);
setupWindow.DeleteGroup.Click=function()
	local windowIndex=setupWindow.ListSel:GetValue();
	local groupIndex=setupWindow.ListSel:GetSelectedIndex();
	if windowIndex==nil or windowIndex==0 then
	else
		-- remove all of the items in the group
		-- remove mouseevent handlers?
		local itemIndex;
		for itemIndex=1,trackWindows[windowIndex].ItemList:GetItemCount() do
			local item=trackWindows[windowIndex].ItemList:GetItem(itemIndex);
			item.Icon:SetVisible(false);
			item:SetVisible(false);
		end
		trackWindows[windowIndex].ItemList:ClearItems();
		-- set the item panel to blank/default info
		setupWindow.ItemSel:SetSelectedIndex(0);
		setupWindow.Icon:SetItemInfo(nil);
		setupWindow.IconName:SetText(Resource[language][15]);
		setupWindow.CritValue:SetText("");
		setupWindow.CritShow:SetSelectedChoice(3);
		setupWindow.LowValue:SetText("");
		setupWindow.LowShow:SetSelectedChoice(3);
		setupWindow.NormalShow:SetSelectedChoice(3);
		setupWindow.HighValue:SetText("");
		setupWindow.HighShow:SetSelectedChoice(3);
		-- remove the group
		trackWindows[windowIndex]:SetVisible(false);
		table.remove(trackWindows,windowIndex);
		setupWindow.ListSel:RemoveItemAt(groupIndex);
		setupWindow.Message:SetForeColor(successColor)
		setupWindow.Message:SetText(Resource[language][42])
	end
end

-- defaults tab
setupWindow.DefaultsTab=Turbine.UI.Label();
setupWindow.DefaultsTab:SetParent(setupWindow.TabBack);
setupWindow.DefaultsTab:SetPosition(1,1);
setupWindow.DefaultsTab:SetSize(setupWindow.TabBack:GetWidth()-2,setupWindow.TabBack:GetHeight()-2);
setupWindow.DefaultsTab:SetBackColor(defaultsTabBackColor);
setupWindow.DefaultsTab:SetVisible(false);
setupWindow.DefaultThresholdBorder=Turbine.UI.Control();
setupWindow.DefaultThresholdBorder:SetParent(setupWindow.DefaultsTab);
setupWindow.DefaultThresholdBorder:SetPosition(10,10);
setupWindow.DefaultThresholdBorder:SetSize(setupWindow.DefaultsTab:GetWidth()-20,200);
setupWindow.DefaultThresholdBorder:SetBackColor(Settings.trimColor);
setupWindow.DefaultThresholdPanel=Turbine.UI.Control();
setupWindow.DefaultThresholdPanel:SetParent(setupWindow.DefaultThresholdBorder);
setupWindow.DefaultThresholdPanel:SetPosition(1,1);
setupWindow.DefaultThresholdPanel:SetSize(setupWindow.DefaultThresholdBorder:GetWidth()-2,setupWindow.DefaultThresholdBorder:GetHeight()-2);
setupWindow.DefaultThresholdPanel:SetBackColor(Settings.backColor);

setupWindow.DefaultThresholdsCaption=Turbine.UI.Label();
setupWindow.DefaultThresholdsCaption:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultThresholdsCaption:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-30,20);
setupWindow.DefaultThresholdsCaption:SetPosition(15,5);
setupWindow.DefaultThresholdsCaption:SetFont(Settings.fontFace);
setupWindow.DefaultThresholdsCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
setupWindow.DefaultThresholdsCaption:SetText(Resource[language][23]);
setupWindow.DefaultCritCaption=Turbine.UI.Label();
setupWindow.DefaultCritCaption:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultCritCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.DefaultCritCaption:SetPosition(15,setupWindow.DefaultThresholdsCaption:GetTop()+setupWindow.DefaultThresholdsCaption:GetHeight()+5);
setupWindow.DefaultCritCaption:SetFont(Settings.fontFace);
setupWindow.DefaultCritCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.DefaultCritCaption:SetText(Resource[language][10]..":");
setupWindow.DefaultCritValue=Turbine.UI.Lotro.TextBox();
setupWindow.DefaultCritValue:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultCritValue:SetPosition(setupWindow.DefaultCritCaption:GetLeft()+setupWindow.DefaultCritCaption:GetWidth()+5,setupWindow.DefaultCritCaption:GetTop());
setupWindow.DefaultCritValue:SetSize(80,20)
setupWindow.DefaultCritValue:SetFont(Settings.fontFace);
setupWindow.DefaultCritValue:SetText(tostring(Settings.critQty));
setupWindow.DefaultCritShow=RadioButtonGroup();
setupWindow.DefaultCritShow:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultCritShow:SetPosition(setupWindow.DefaultCritValue:GetLeft(),setupWindow.DefaultCritValue:GetTop()+setupWindow.DefaultCritValue:GetHeight())
setupWindow.DefaultCritShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.DefaultCritShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.DefaultCritShow.IconWidth=16;
setupWindow.DefaultCritShow.IconHeight=16;
setupWindow.DefaultCritShow:SetBorderColor(Settings.backColor);
setupWindow.DefaultCritShow:SetBackColor(Settings.backColor);
setupWindow.DefaultCritShow:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-setupWindow.DefaultCritShow:GetLeft()-30,18);
setupWindow.DefaultCritShow:AddChoice(Resource[language][19],true);
setupWindow.DefaultCritShow:AddChoice(Resource[language][20],false);
if Settings.critShow then
	setupWindow.DefaultCritShow:SetSelectedChoice(1);
else
	setupWindow.DefaultCritShow:SetSelectedChoice(2);
end
setupWindow.Sep4=Turbine.UI.Control();
setupWindow.Sep4:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.Sep4:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-30,1);
setupWindow.Sep4:SetPosition(15,setupWindow.DefaultCritShow:GetTop()+setupWindow.DefaultCritShow:GetHeight()+4);
setupWindow.Sep4:SetBackColor(Settings.trimColor);
setupWindow.DefaultLowCaption=Turbine.UI.Label();
setupWindow.DefaultLowCaption:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultLowCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.DefaultLowCaption:SetPosition(setupWindow.DefaultCritCaption:GetLeft(),setupWindow.Sep4:GetTop()+setupWindow.Sep4:GetHeight()+4);
setupWindow.DefaultLowCaption:SetFont(Settings.fontFace);
setupWindow.DefaultLowCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.DefaultLowCaption:SetText(Resource[language][11]..":");
setupWindow.DefaultLowValue=Turbine.UI.Lotro.TextBox();
setupWindow.DefaultLowValue:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultLowValue:SetPosition(setupWindow.DefaultCritValue:GetLeft(),setupWindow.DefaultLowCaption:GetTop());
setupWindow.DefaultLowValue:SetSize(80,20)
setupWindow.DefaultLowValue:SetFont(Settings.fontFace);
setupWindow.DefaultLowValue:SetText(tostring(Settings.lowQty));
setupWindow.DefaultLowShow=RadioButtonGroup();
setupWindow.DefaultLowShow:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultLowShow:SetPosition(setupWindow.DefaultLowValue:GetLeft(),setupWindow.DefaultLowValue:GetTop()+setupWindow.DefaultLowValue:GetHeight())
setupWindow.DefaultLowShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.DefaultLowShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.DefaultLowShow.IconWidth=16;
setupWindow.DefaultLowShow.IconHeight=16;
setupWindow.DefaultLowShow:SetBorderColor(Settings.backColor);
setupWindow.DefaultLowShow:SetBackColor(Settings.backColor);
setupWindow.DefaultLowShow:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-setupWindow.DefaultLowShow:GetLeft()-30,18);
setupWindow.DefaultLowShow:AddChoice(Resource[language][19],true);
setupWindow.DefaultLowShow:AddChoice(Resource[language][20],false);
if Settings.lowShow then
	setupWindow.DefaultLowShow:SetSelectedChoice(1);
else
	setupWindow.DefaultLowShow:SetSelectedChoice(2);
end
setupWindow.Sep5=Turbine.UI.Control();
setupWindow.Sep5:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.Sep5:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-30,1);
setupWindow.Sep5:SetPosition(15,setupWindow.DefaultLowShow:GetTop()+setupWindow.DefaultLowShow:GetHeight()+4);
setupWindow.Sep5:SetBackColor(Settings.trimColor);

setupWindow.DefaultNormalCaption=Turbine.UI.Label();
setupWindow.DefaultNormalCaption:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultNormalCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.DefaultNormalCaption:SetPosition(setupWindow.DefaultLowCaption:GetLeft(),setupWindow.Sep5:GetTop()+setupWindow.Sep5:GetHeight()+4);
setupWindow.DefaultNormalCaption:SetFont(Settings.fontFace);
setupWindow.DefaultNormalCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.DefaultNormalCaption:SetText(Resource[language][22]..":");
setupWindow.DefaultNormalShow=RadioButtonGroup();
setupWindow.DefaultNormalShow:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultNormalShow:SetPosition(setupWindow.DefaultCritShow:GetLeft(),setupWindow.DefaultNormalCaption:GetTop())
setupWindow.DefaultNormalShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.DefaultNormalShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.DefaultNormalShow.IconWidth=16;
setupWindow.DefaultNormalShow.IconHeight=16;
setupWindow.DefaultNormalShow:SetBorderColor(Settings.backColor);
setupWindow.DefaultNormalShow:SetBackColor(Settings.backColor);
setupWindow.DefaultNormalShow:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-setupWindow.DefaultNormalShow:GetLeft()-30,18);
setupWindow.DefaultNormalShow:AddChoice(Resource[language][19],true);
setupWindow.DefaultNormalShow:AddChoice(Resource[language][20],false);
if Settings.normalShow then
	setupWindow.DefaultNormalShow:SetSelectedChoice(1);
else
	setupWindow.DefaultNormalShow:SetSelectedChoice(2);
end
setupWindow.Sep6=Turbine.UI.Control();
setupWindow.Sep6:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.Sep6:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-30,1);
setupWindow.Sep6:SetPosition(15,setupWindow.DefaultNormalShow:GetTop()+setupWindow.DefaultNormalShow:GetHeight()+4);
setupWindow.Sep6:SetBackColor(Settings.trimColor);

setupWindow.DefaultHighCaption=Turbine.UI.Label();
setupWindow.DefaultHighCaption:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultHighCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.DefaultHighCaption:SetPosition(setupWindow.DefaultLowCaption:GetLeft(),setupWindow.Sep6:GetTop()+setupWindow.Sep6:GetHeight()+4);
setupWindow.DefaultHighCaption:SetFont(Settings.fontFace);
setupWindow.DefaultHighCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.DefaultHighCaption:SetText(Resource[language][12]..":");
setupWindow.DefaultHighValue=Turbine.UI.Lotro.TextBox();
setupWindow.DefaultHighValue:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultHighValue:SetPosition(setupWindow.DefaultCritValue:GetLeft(),setupWindow.DefaultHighCaption:GetTop());
setupWindow.DefaultHighValue:SetSize(80,20)
setupWindow.DefaultHighValue:SetFont(Settings.fontFace);
setupWindow.DefaultHighValue:SetText(tostring(Settings.highQty));
setupWindow.DefaultHighShow=RadioButtonGroup();
setupWindow.DefaultHighShow:SetParent(setupWindow.DefaultThresholdPanel);
setupWindow.DefaultHighShow:SetPosition(setupWindow.DefaultHighValue:GetLeft(),setupWindow.DefaultHighValue:GetTop()+setupWindow.DefaultHighValue:GetHeight())
setupWindow.DefaultHighShow.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.DefaultHighShow.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.DefaultHighShow.IconWidth=16;
setupWindow.DefaultHighShow.IconHeight=16;
setupWindow.DefaultHighShow:SetBorderColor(Settings.backColor);
setupWindow.DefaultHighShow:SetBackColor(Settings.backColor);
setupWindow.DefaultHighShow:SetSize(setupWindow.DefaultThresholdPanel:GetWidth()-setupWindow.DefaultHighShow:GetLeft()-30,18);
setupWindow.DefaultHighShow:AddChoice(Resource[language][19],true);
setupWindow.DefaultHighShow:AddChoice(Resource[language][20],false);
if Settings.highShow then
	setupWindow.DefaultHighShow:SetSelectedChoice(1);
else
	setupWindow.DefaultHighShow:SetSelectedChoice(2);
end
setupWindow.DefaultShowCaption=Turbine.UI.Label();
setupWindow.DefaultShowCaption:SetParent(setupWindow.DefaultsTab);
setupWindow.DefaultShowCaption:SetSize(setupWindow.ListSelCaption:GetWidth(),20);
setupWindow.DefaultShowCaption:SetPosition(15,setupWindow.DefaultThresholdBorder:GetTop()+setupWindow.DefaultThresholdBorder:GetHeight()+5);
setupWindow.DefaultShowCaption:SetFont(Settings.fontFace);
setupWindow.DefaultShowCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
setupWindow.DefaultShowCaption:SetText(Resource[language][33]..":");

setupWindow.DefaultShowTotals=RadioButtonGroup();
setupWindow.DefaultShowTotals:SetParent(setupWindow.DefaultsTab);
setupWindow.DefaultShowTotals:SetFont(Settings.fontFace);
setupWindow.DefaultShowTotals:SetSize(setupWindow.DefaultsTab:GetWidth()-35-setupWindow.DefaultShowCaption:GetWidth(),20)
setupWindow.DefaultShowTotals.UnselectedIcon="GaranStuff/ItemTracker/Resources/RB_unselected.tga";
setupWindow.DefaultShowTotals.SelectedIcon="GaranStuff/ItemTracker/Resources/RB_selected.tga";
setupWindow.DefaultShowTotals.IconWidth=16;
setupWindow.DefaultShowTotals.IconHeight=16;
setupWindow.DefaultShowTotals:SetBorderColor(nil);
setupWindow.DefaultShowTotals:SetBackColor(nil);
setupWindow.DefaultShowTotals:SetPosition(setupWindow.DefaultShowCaption:GetLeft()+setupWindow.DefaultShowCaption:GetWidth()+5,setupWindow.DefaultShowCaption:GetTop());
setupWindow.DefaultShowTotals:AddChoice(Resource[language][31],{true,false});
setupWindow.DefaultShowTotals:AddChoice(Resource[language][30],{false,true});
setupWindow.DefaultShowTotals:AddChoice(Resource[language][32],{true,true});
if Settings.showTotals then
	if Settings.showCurrent then
		setupWindow.DefaultShowTotals:SetSelectedChoice(3)
	else
		setupWindow.DefaultShowTotals:SetSelectedChoice(2)
	end
else
	if Settings.showCurrent then
		setupWindow.DefaultShowTotals:SetSelectedChoice(1)
	end
end

setupWindow.OutlineQty=Turbine.UI.Lotro.CheckBox();
setupWindow.OutlineQty:SetParent(setupWindow.DefaultsTab);
setupWindow.OutlineQty:SetSize(setupWindow.DefaultShowTotals:GetSize());
setupWindow.OutlineQty:SetPosition(setupWindow.DefaultShowTotals:GetLeft(),setupWindow.DefaultShowTotals:GetTop()+setupWindow.DefaultShowTotals:GetHeight()+5);
setupWindow.OutlineQty:SetFont(Settings.fontFace);
setupWindow.OutlineQty:SetText(Resource[language][34]);
setupWindow.OutlineQty:SetChecked(Settings.outlineQtyText);

setupWindow.SaveDefaults=Turbine.UI.Lotro.Button();
setupWindow.SaveDefaults:SetParent(setupWindow.DefaultsTab);
setupWindow.SaveDefaults:SetFont(Settings.fontFace);
setupWindow.SaveDefaults:SetSize(120,18);
setupWindow.SaveDefaults:SetPosition(setupWindow.DefaultsTab:GetWidth()/2-60,setupWindow.DefaultsTab:GetHeight()-25);
setupWindow.SaveDefaults:SetText(Resource[language][29]);
setupWindow.SaveDefaults.Click=function()
	Settings.critQty=tonumber(setupWindow.DefaultCritValue:GetText());
	Settings.lowQty=tonumber(setupWindow.DefaultLowValue:GetText());
	Settings.highQty=tonumber(setupWindow.DefaultHighValue:GetText());
	Settings.critShow=(setupWindow.DefaultCritShow:GetSelectedChoice()==1);
	Settings.lowShow=(setupWindow.DefaultLowShow:GetSelectedChoice()==1);
	Settings.normalShow=(setupWindow.DefaultNormalShow:GetSelectedChoice()==1);
	Settings.highShow=(setupWindow.DefaultHighShow:GetSelectedChoice()==1);
	Settings.showTotals=setupWindow.DefaultShowTotals:GetValue()[2];
	Settings.showCurrent=setupWindow.DefaultShowTotals:GetValue()[1];
	Settings.outlineQtyText=setupWindow.OutlineQty:IsChecked();
	-- need to call SetQty on every entry, passing the old Qty as the parm
	-- that will reevaluate the crit/low/norm/high status as well as setting view status
	for k,v in pairs(trackEntry) do
		if Settings.outlineQtyText then
			v.Qty:SetFontStyle(Turbine.UI.FontStyle.Outline);
			v.TotalQty:SetFontStyle(Turbine.UI.FontStyle.Outline);
		else
			v.Qty:SetFontStyle(Turbine.UI.FontStyle.None);
			v.TotalQty:SetFontStyle(Turbine.UI.FontStyle.None);
		end
		v:SetQty(v:GetQty());
	end
end

-- tab buttons
setupWindow.ListButtonBack=Turbine.UI.Control()
setupWindow.ListButtonBack:SetParent(setupWindow)
setupWindow.ListButtonBack:SetPosition(10,45);
setupWindow.ListButtonBack:SetSize(100,20);
setupWindow.ListButtonBack:SetBackColor(listTabTrimColor)
setupWindow.ListButton=Turbine.UI.Label()
setupWindow.ListButton:SetParent(setupWindow)
setupWindow.ListButton:SetPosition(11,46);
setupWindow.ListButton:SetSize(98,20);
setupWindow.ListButton:SetBackColor(listTabBackColor);
setupWindow.ListButton:SetFont(Settings.fontFace);
setupWindow.ListButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
setupWindow.ListButton:SetText(Resource[language][16]);
setupWindow.ListButton.MouseClick=function()
	setupWindow.ListTab:SetVisible(true);
	setupWindow.TabBack:SetBackColor(listTabTrimColor);
	setupWindow.DefaultsTab:SetVisible(false);
	setupWindow.ListButtonBack:SetTop(45);
	setupWindow.ListButtonBack:SetHeight(20);
	setupWindow.ListButton:SetTop(46);
	setupWindow.ListButton:SetHeight(20);
	setupWindow.DefaultsButtonBack:SetTop(49);
	setupWindow.DefaultsButtonBack:SetHeight(16);
	setupWindow.DefaultsButton:SetTop(50);
	setupWindow.DefaultsButton:SetHeight(15);
end
setupWindow.DefaultsButtonBack=Turbine.UI.Control()
setupWindow.DefaultsButtonBack:SetParent(setupWindow)
setupWindow.DefaultsButtonBack:SetPosition(111,49);
setupWindow.DefaultsButtonBack:SetSize(100,16);
setupWindow.DefaultsButtonBack:SetBackColor(defaultsTabTrimColor)
setupWindow.DefaultsButton=Turbine.UI.Label()
setupWindow.DefaultsButton:SetParent(setupWindow)
setupWindow.DefaultsButton:SetPosition(112,50);
setupWindow.DefaultsButton:SetSize(98,15);
setupWindow.DefaultsButton:SetBackColor(defaultsTabBackColor);
setupWindow.DefaultsButton:SetFont(Settings.fontFace);
setupWindow.DefaultsButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
setupWindow.DefaultsButton:SetText(Resource[language][17]);
setupWindow.DefaultsButton.MouseClick=function()
	setupWindow.DefaultsTab:SetVisible(true);
	setupWindow.TabBack:SetBackColor(defaultsTabTrimColor);
	setupWindow.ListTab:SetVisible(false);
	setupWindow.DefaultsButtonBack:SetTop(45);
	setupWindow.DefaultsButtonBack:SetHeight(20);
	setupWindow.DefaultsButton:SetTop(46);
	setupWindow.DefaultsButton:SetHeight(20);
	setupWindow.ListButtonBack:SetTop(49);
	setupWindow.ListButtonBack:SetHeight(16);
	setupWindow.ListButton:SetTop(50);
	setupWindow.ListButton:SetHeight(15);
end
setupWindow.Message=Turbine.UI.Label();
setupWindow.Message:SetParent(setupWindow);
setupWindow.Message:SetSize(setupWindow:GetWidth()-60,20);
setupWindow.Message:SetPosition(30,setupWindow:GetHeight()-30);
setupWindow.Message:SetFont(Settings.fontFace);
setupWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

setupWindow.ItemSel:SetVisible(false);
setupWindow.ItemBorder:SetVisible(false);
setupWindow:SetText(Resource[language][2]);
setupWindow.ListSel:SetZOrder(2);
setupWindow.ItemSel:SetZOrder(1);
setupWindow.ListSel.SelectedIndexChanged=function()
	setupWindow.ItemSel:ClearList();
	setupWindow.ItemSel:AddItem(Resource[language][18],0);
	local index=setupWindow.ListSel:GetValue();
	if index~=nil and index>0 then
		setupWindow.GroupValue:SetText(trackWindows[index].Name);
		local itemIndex;
		for itemIndex=1,trackWindows[index].ItemList:GetItemCount() do
			setupWindow.ItemSel:AddItem(trackWindows[index].ItemList:GetItem(itemIndex).Icon:GetItemInfo():GetName(),itemIndex);
		end
		setupWindow.LeftValue:SetText(trackWindows[index]:GetLeft());
		setupWindow.TopValue:SetText(trackWindows[index]:GetTop());
		setupWindow.ItemSelCaption:SetVisible(true);
		setupWindow.ItemSel:SetVisible(true);
		setupWindow.ItemBorder:SetVisible(true);
		setupWindow.DeleteGroup:SetEnabled(true);
		if trackWindows[index].ItemList.ShowTotals==nil then
			setupWindow.ShowTotals:SetSelectedChoice(3);
		elseif trackWindows[index].ItemList.ShowTotals then
			setupWindow.ShowTotals:SetSelectedChoice(1);
		else
			setupWindow.ShowTotals:SetSelectedChoice(2);
		end
		if trackWindows[index].ItemList.ShowCurrent==nil then
			setupWindow.ShowCurrent:SetSelectedChoice(3);
		elseif trackWindows[index].ItemList.ShowCurrent then
			setupWindow.ShowCurrent:SetSelectedChoice(1);
		else
			setupWindow.ShowCurrent:SetSelectedChoice(2);
		end
	else
		setupWindow.ItemSelCaption:SetVisible(false);
		setupWindow.ItemSel:SetVisible(false);
		setupWindow.ItemBorder:SetVisible(false);
		setupWindow.DeleteGroup:SetEnabled(false);
		setupWindow.ShowTotals:SetSelectedChoice(3);
		setupWindow.ShowCurrent:SetSelectedChoice(3);
	end
	setupWindow.ItemSel:SetSelectedIndex(1);
	setupWindow.SaveItem:SetEnabled(false);
	setupWindow.DeleteItem:SetEnabled(false);
end
setupWindow.ItemSel.SelectedIndexChanged=function()
	local index=setupWindow.ListSel:GetValue();
	local itemIndex=setupWindow.ItemSel:GetValue();
	if index~=nil and index>0 and itemIndex~=nil and itemIndex>0 then
		local item=trackWindows[index].ItemList:GetItem(itemIndex);
		if item.Crit==nil then
			setupWindow.CritValue:SetText("");
		else
			setupWindow.CritValue:SetText(tostring(item.Crit));
		end
		if item.Low==nil then
			setupWindow.LowValue:SetText("");
		else
			setupWindow.LowValue:SetText(tostring(item.Crit));
		end
		if item.High==nil then
			setupWindow.HighValue:SetText("");
		else
			setupWindow.HighValue:SetText(tostring(item.Crit));
		end
		setupWindow.Icon:SetItemInfo(item.Icon:GetItemInfo());
		setupWindow.IconName:SetText(item.Icon:GetItemInfo():GetName());
		if item.CritShow==nil then
			setupWindow.CritShow:SetSelectedChoice(3);
		elseif item.CritShow then
			setupWindow.CritShow:SetSelectedChoice(1);
		else
			setupWindow.CritShow:SetSelectedChoice(2);
		end
		if item.LowShow==nil then
			setupWindow.LowShow:SetSelectedChoice(3);
		elseif item.LowShow then
			setupWindow.LowShow:SetSelectedChoice(1);
		else
			setupWindow.LowShow:SetSelectedChoice(2);
		end
		if item.NormalShow==nil then
			setupWindow.NormalShow:SetSelectedChoice(3);
		elseif item.NormalShow then
			setupWindow.NormalShow:SetSelectedChoice(1);
		else
			setupWindow.NormalShow:SetSelectedChoice(2);
		end
		if item.HighShow==nil then
			setupWindow.HighShow:SetSelectedChoice(3);
		elseif item.HighShow then
			setupWindow.HighShow:SetSelectedChoice(1);
		else
			setupWindow.HighShow:SetSelectedChoice(2);
		end
		setupWindow.SaveItem:SetEnabled(true);
		setupWindow.DeleteItem:SetEnabled(true);
	else
		setupWindow.Icon:SetItemInfo(nil);
		setupWindow.IconName:SetText(Resource[language][15]);
		setupWindow.SaveItem:SetEnabled(false);
		setupWindow.DeleteItem:SetEnabled(false);
	end
end

setupWindow.KeyUp=function(sender, args)
	if bShowKeyDown==true then
		Turbine.Shell.WriteLine("KeyUp Action="..args.Action..", .Alt="..tostring(args.Alt)..", .Control="..tostring(args.Control)..", .Shift="..tostring(args.Shift))
	end
end

setupWindow.KeyDown=function(sender, args)
	if bShowKeyDown==true then
		Turbine.Shell.WriteLine("KeyDown Action="..args.Action..", .Alt="..tostring(args.Alt)..", .Control="..tostring(args.Control)..", .Shift="..tostring(args.Shift))
	end
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		setupWindow:SetVisible( false );
	end
	if ( args.Action == 268435579 ) then -- reposition UI
		moveToggle=not moveToggle;
		for k,v in ipairs(trackWindows) do
			v.MoveText:SetText(Resource[language][2].." "..tostring(k));
			v.MovePanel:SetVisible(moveToggle);
		end
	end
	if ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			setupWindow:SetVisible(setupVisible);
			for k,v in ipairs(trackWindows) do
				v:SetVisible(true);
			end
		else
			setupVisible=setupWindow:IsVisible();
			setupWindow:SetVisible(false);
			for k,v in ipairs(trackWindows) do
				v:SetVisible(false)
			end
		end
	end
end

setupWindow:SetWantsKeyEvents(true);
setupWindow:SetWantsUpdates(true)

setupWindow.shellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand("ItemTracker",setupWindow.shellCmd);

setupWindow.shellCmd.Execute = function(sender, cmd, args)
	if (string.lower(cmd) == "itemtracker") then
		if (string.lower(args)=="setup") then
			setupWindow:SetVisible(true);
		elseif (string.lower(args)=="hide") then
			setupWindow:SetVisible(false);
		elseif (string.lower(args)=="debug on") then
			Settings.debug=true;
			if debugWindow==nil then
				debugWindow=DebugWindow();
			end
			debugWindow:SetVisible(true);
		elseif (string.lower(args)=="debug off") then
			Settings.debug=false;
			if debugWindow~=nil then
				debugWindow:SetVisible(false);
			end
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /ItemTracker setup");
			Turbine.Shell.WriteLine("       Displays the setup window.");
			Turbine.Shell.WriteLine("  /ItemTracker hide");
			Turbine.Shell.WriteLine("       Hides the setup window.");
		end
	end
end
setupWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /ItemTracker setup\n       Displays the setup window.\n  /ItemTracker hide\n       Hides the setup window.");
end

setupWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return("Item Tracker - usage: /ItemTracker setup | hide");
end

setupWindow.Update=function( sender, args )
	if (Plugins.ItemTracker ~= nil) and (not setupWindow.Loaded) then
		setupWindow.Loaded=true;
		setupWindow:SetWantsUpdates(false);
		LoadData();
		Turbine.Shell.WriteLine("Item Tracker "..Plugins.ItemTracker:GetVersion().." "..Resource[language][3]);
		Plugins.ItemTracker.Unload = function(setupWindow,sender,args)
			UnloadPlugin();
		end
	end
end

ItemEntry=class(Turbine.UI.Control)
function ItemEntry:Constructor()
	-- this represents one row of the tracking display
	-- each row has a qty column, icon and total qty column - the icons will line up vertically
	-- hovering over the qty does nothing
	-- hovering over the total qty displays a menu list of which characters have which qty
	-- the icon is an iteminfocontrol so hovering over it will pop the tooltip
	Turbine.UI.Control.Constructor(self);
	self:SetSize(1,20); -- bogus size until SetQty is called
	self.Qty=Turbine.UI.Label();
	self.Qty:SetParent(self);
	self.Qty:SetHeight(20);
	self.Qty:SetFont(Settings.fontFace);
	self.Qty:SetForeColor(Settings.fontColor);
	self.Qty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	if Settings.outlineQtyText then
		self.Qty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	end
	self.Qty:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.SetQty=function(sender,newQty)
		if newQty==nil then newQty=0 end
		newQty=tonumber(newQty);
		local newWidth=fontMetric:GetTextWidth(tostring(newQty),20);
		if newWidth>self:GetParent().Col1 then
			self:GetParent():SetCol1Width(newWidth);
		end

		local low=self.Low;
		if low==nil then low=Settings.lowQty end
		if low==nil then low=-1 end
		local crit=self.Crit;
		if crit==nil then crit=Settings.critQty end
		if crit==nil then crit=-1 end
		local high=self.High;
		if high==nil then high=Settings.highQty end
		local show=self.NormalShow;
		if high~=nil and newQty>=high then
			self.Qty:SetForeColor(Settings.highColor);
			show=self.HighShow;
			if show==nil then show=Settings.highShow end;
		elseif newQty<=crit then
			self.Qty:SetForeColor(Settings.critColor);
			show=self.CritShow;
			if show==nil then show=Settings.critShow end;
		elseif newQty<=low then
			self.Qty:SetForeColor(Settings.lowColor);
			show=self.LowShow;
			if show==nil then show=Settings.lowShow end;
		else
			self.Qty:SetForeColor(Settings.fontColor);
			if show==nil then show=Settings.normalShow end
		end
		self.Qty:SetText(newQty);
		if show then
			self:SetHeight(20);
			self:SetVisible(true);
		else
			self:SetHeight(0);
			self:SetVisible(false);
		end
		local name=self.Icon:GetItemInfo():GetName();
		if accountItemQty~=nil and accountItemQty[name]~=nil then
			newQty=newQty+accountItemQty[name].Total;
		end
		newWidth=fontMetric:GetTextWidth(tostring(newQty),20);
		if newWidth>self:GetParent().Col3 then
			self:GetParent():SetCol3Width(newWidth);
		end
		self.TotalQty:SetText(newQty);
		self:Layout();
	end
	self.GetQty=function(sender)
		local qty=self.Qty:GetText();
		if qty==nil or qty=="" then qty=0 end
		return tonumber(qty);
	end
	self.IconBack=Turbine.UI.Control();
	self.IconBack:SetParent(self);
	self.IconBack:SetSize(16,16);
	self.IconBack:SetPosition(0,0);
	self.Icon=Turbine.UI.Lotro.ItemInfoControl();
	self.Icon:SetParent(self.IconBack);
	self.Icon:SetSize(34,34);
	self.Icon:SetStretchMode(2);
	self.Icon:SetSize(16,16);
	self.SetItem=function(sender,itemCode)
		-- pass an itemCode
		if itemCode~=nil then
			local sc=Turbine.UI.Lotro.Shortcut(2,0);
			sc:SetData(itemCode);
			local itemInfo=sc:GetItem():GetItemInfo();
			if itemInfo~=nil then
				local itemName=itemInfo:GetName();
				if itemName~=nil and itemName~="" then
					local entry=trackEntry[itemName];
					if entry==nil then
						trackEntry[itemName]=self;
						self.Icon:SetItemInfo(itemInfo);
						self.Icon.ItemCode=itemCode;
					else
						Turbine.Shell.WriteLine("ItemTracker:SetItem error: duplicate item")
					end
				else
					Turbine.Shell.WriteLine("ItemTracker:SetItem error: itemName is nil or blank")
				end
			else
				Turbine.Shell.WriteLine("ItemTracker:SetItem error: itemInfo is nil")
			end
		else
			Turbine.Shell.WriteLine("ItemTracker:SetItem error: itemCode is nil")
		end
	end
	self.SetThresholds=function(sender,crit,critShow,low,lowShow,normalShow,high,highShow)
		self.Crit=crit;
		self.CritShow=critShow;
		self.Low=low;
		self.LowShow=lowShow;
		self.NormalShow=normalShow;
		self.High=high;
		self.HighShow=highShow;
	end

	self.TotalQty=Turbine.UI.Label();
	self.TotalQty:SetParent(self);
	self.TotalQty:SetHeight(20);
	self.TotalQty:SetFont(Settings.fontFace);
	self.TotalQty:SetForeColor(Settings.fontColor);
	self.TotalQty:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.TotalQty:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.TotalQty:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.IconBack:SetMouseVisible(false);
	self.Icon:SetMouseVisible(false);
	self.TotalQty:SetMouseVisible(true);
	self.Icon.MouseClick=function(sender,args)
		-- for some reason, ItemInfoControls still receive clicks even after SetMouseVisible(false)
		-- this redirects the click to the parent control
		self.MouseClick(self,args);
	end
	self.MouseClick=function(sender,args)
--		Turbine.Shell.WriteLine("item:"..tostring(self.Icon:GetItemInfo():GetName()).." ("..tostring(self.Icon.ItemCode)..")"..tostring(sender))
	end
	self.TotalQty:SetAllowDrop(true)
	self.TotalQty.DragDrop=function(sender,args)
		self:AddDefaultItem(args);
	end
	self.Icon:SetAllowDrop(true)
	self.Icon.DragDrop=function(sender,args)
		self:AddDefaultItem(args);
	end
	self.Qty:SetAllowDrop(true)
	self.Qty.DragDrop=function(sender,args)
		self:AddDefaultItem(args);
	end
	self.AddDefaultItem=function(sender,args)
		local shortcut = args.DragDropInfo:GetShortcut();
		if ( shortcut ~= nil ) then
			if shortcut:GetType()==2 then
				setupWindow:SetVisible(true);
				setupWindow.ListSel:SetSelectedIndex(self:GetParent():GetParent().Index+1);
				setupWindow.ListSel:SelectedIndexChanged();
				setupWindow.ItemSel:SetSelectedIndex(0);
				setupWindow.Icon.DragDrop(setupWindow.Icon,args);
				setupWindow.CritValue:SetText("");
				setupWindow.CritShow:SetSelectedChoice(3);
				setupWindow.LowValue:SetText("");
				setupWindow.LowShow:SetSelectedChoice(3);
				setupWindow.NormalShow:SetSelectedChoice(3);
 				setupWindow.HighValue:SetText("");
				setupWindow.HighShow:SetSelectedChoice(3);
			end
		end
	end

	self.TotalQty.MouseHover=function(sender,args)
		-- populate the detail menu
		local itemList=detailMenu:GetItems();
		itemList:Clear();
		local tmpList={};
		local index=1;
		local sharedStorage;
		local itemName=self.Icon:GetItemInfo():GetName();
		if accountItemQty[itemName]~=nil then
			for k,v in pairs(accountItemQty[itemName]) do
				if k~="Total" then
					if k=="Shared Storage" then
						sharedStorage=v;
					else
						tmpList[index]=tostring(k)..": "..tostring(v);
						index=index+1;
					end
				end
			end
		end
		-- now add the current character qty
		tmpList[index]=charName..": "..tostring(self.Qty:GetText());
		-- now sort the list alphabetically
		table.sort(tmpList);

		-- and last, add the shared storage as the first entry
		if sharedStorage~=nil then
			table.insert(tmpList,1,"Shared Storage: "..tostring(sharedStorage))
		end

		for k,v in pairs(tmpList) do
			itemList:Add(Turbine.UI.MenuItem(v));
		end
		detailMenu:ShowMenuAt(Turbine.UI.Display:GetMouseX(),Turbine.UI.Display:GetMouseY()+20);
	end
	self.TotalQty.MouseLeave=function()
		detailMenu:Close();
	end
	self.SetTotalQty=function(sender,newQty)
		-- this function should no longer be called
		if newQty==nil then newQty=0 end
		newQty=tonumber(newQty);
		self.TotalQty:SetText(newQty);
		self:Layout();
	end
	self.GetTotalQty=function(sender)
		local qty=self.TotalQty:GetText();
		if qty==nil or qty=="" then qty=0 end
		return tonumber(qty);
	end
	self.Layout=function()
		local parent=self:GetParent();
		local col1=parent.Col1;
		local showTotals=parent.ShowTotals;
		local showCurrent=parent.ShowCurrent;
		if showTotals==nil then showTotals=Settings.showTotals end
		if showCurrent==nil then showCurrent=Settings.showCurrent end

		self.TotalQty:SetVisible(showTotals);
		self.Qty:SetVisible(showCurrent);
		if col1>parent.Col1 then
			parent.Col1=col1;
			-- resize all other children for this col
		else
			col1=parent.Col1;
		end
		local col2=16;
		local col3=parent.Col3;

		local tot=col1+col2+col3+10;
		self.Qty:SetWidth(col1);
		self.IconBack:SetLeft(col1+5);
		self.TotalQty:SetLeft(col1+col2+10);
		self.TotalQty:SetWidth(col3);
		self:SetWidth(tot);
		-- reapply the stretchmode since sizing the parent messes up the stretching of iteminfo controls
		self.Icon:SetSize(34,34);
		self.Icon:SetStretchMode(2);
		self.Icon:SetSize(16,16);
	end
end

TrackWindow=class(Turbine.UI.Window)
function TrackWindow:Constructor()
	-- each track window can have several items and can be positioned separately
	Turbine.UI.Window.Constructor(self);
	self:SetSize(200,40); -- dummy default so that resizing takes effect properly
	self:SetPosition(300,300);
-- create movement tab
	self.ItemList=Turbine.UI.ListBox();
	self.ItemList:SetParent(self);
	self.ItemList:SetSize(self:GetWidth(),self:GetHeight()-20);
	self.ItemList:SetPosition(0,20);
	self.ItemList.Col1=1;
	self.ItemList.Col3=1;
	self.ItemList:SetHeight(0);
	self:SetMouseVisible(false);
	self.ItemList:SetMouseVisible(false);
	self:SetVisible(true);
	self.ItemList.ItemAdded=function()
		local newHeight=self.ItemList:GetItemCount()*20;
		self.ItemList:SetHeight(newHeight);
		self:SetHeight(newHeight+20);
	end
	self.ItemList.ItemRemoved=function()
		self.ItemList:SetHeight(self.ItemList:GetItemCount()*20);
		self:SetHeight(self.ItemList:GetHeight()+20);
	end
	self.ItemList.SetCol1Width=function(sender,newWidth)
		self.ItemList.Col1=newWidth;
		self.ItemList:SetWidth(self.ItemList.Col1+self.ItemList.Col3+26);
		self:SetWidth(self.ItemList.Col1+self.ItemList.Col3+26);
		local index
		for index=1,self.ItemList:GetItemCount() do
			self.ItemList:GetItem(index):Layout();
		end
	end
	self.ItemList.SetCol3Width=function(sender,newWidth)
		self.ItemList.Col3=newWidth;
		self.ItemList:SetWidth(self.ItemList.Col1+self.ItemList.Col3+26);
		self:SetWidth(self.ItemList.Col1+self.ItemList.Col3+26);
		local index
		for index=1,self.ItemList:GetItemCount() do
			self.ItemList:GetItem(index):Layout();
		end
	end

	self.MovePanel=Turbine.UI.Control();
	self.MovePanel:SetParent(self);
	self.MovePanel:SetSize(self:GetWidth(),19);
	self.MovePanel:SetBackColor(Turbine.UI.Color(.5,0,0,0));
	self.Move2=Turbine.UI.Control();
	self.Move2:SetParent(self.MovePanel);
	self.Move2:SetSize(self:GetWidth()-17,12);
	self.Move2:SetPosition(17,2);
	self.Move2:SetBackground("GaranStuff/ItemTracker/Resources/move2.tga");
	self.Move2:SetMouseVisible(false);
	self.Move=Turbine.UI.Control();
	self.Move:SetParent(self.MovePanel);
	self.Move:SetSize(19,19);
	self.Move:SetBackground("GaranStuff/ItemTracker/Resources/move.tga");
	self.Move:SetMouseVisible(false);
	self.MoveText=Turbine.UI.Label();
	self.MoveText:SetParent(self.Move2);
	self.MoveText:SetSize(self.Move2:GetWidth()-2,12);
	self.MoveText:SetPosition(1,2);
	self.MoveText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
	self.MoveText:SetText("HI");
--	self.MoveText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.MoveText:SetMouseVisible(false);
	self.MovePanel:SetVisible(false);

	self.MoveX=-1;
	self.MoveY=0;
	self.Moving=false;

	self.MovePanel.MouseDown=function()
	end

	self.MovePanel.MouseClick = function(sender,args)
		if self.Moving then
			self.Moving=false;
			self.MoveX=-1;
		end
	end
	self.MovePanel.MouseDown=function(sender,args)
		setupWindow.ListSel:SetSelectedIndex(self.Index+1);
		setupWindow.ListSel:SelectedIndexChanged();
		self.MoveX=args.X;
		self.MoveY=args.Y;
	end
	self.MovePanel.MouseUp=function(sender,args)
		self.MoveX=-1;
		self.MoveY=0;
	end

	self.MovePanel.MouseEnter=function(sender,args)
		self:SetOpacity(1);
	end

	self.MovePanel.MouseLeave=function(sender,args)
		self:SetOpacity(Settings.opacity);
	end
	self.MovePanel.MouseMove=function(sender,args)
		if self.MoveX~=-1 and (args.X~=self.MoveX or args.Y~= self.MoveY) then
			self.Moving=true;
			local newLeft=self:GetLeft()-(self.MoveX-args.X)
			local newTop=self:GetTop()-(self.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			if newTop<-19 then newTop=-19 end;
			if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			setupWindow.TopValue:SetText(newTop);
			setupWindow.LeftValue:SetText(newLeft);
			self:SetPosition(newLeft,newTop);
		end
	end
end

trackWindows={}
trackEntry={}
backpackImage={}

backPack=localPlayer:GetBackpack()
function quantityChanged(sender,args)
	if sender~=nil and sender.GetItemInfo~=nil then
		local name=sender:GetItemInfo():GetName();
		if name~=nil then
			updateQuantity(name);
		end
	end
end
function updateQuantity(itemName,skipIndex)
	if Settings.debug then
		Turbine.Shell.WriteLine("updateQuantity")
	end
	local qty=0;
	local skipQty=0;
	local index;
	local tmpEntry=trackEntry[itemName];
	if tmpEntry~=nil then
		for index=1,backPack:GetSize() do
			local item=backPack:GetItem(index);
			if item~=nil then
				if item:GetItemInfo():GetName()==itemName then
					qty=qty+item:GetQuantity();
					if index==skipIndex then
						skipQty=item:GetQuantity()
					end
				end
			end
		end
		local oldQty=tmpEntry:GetQty()
		tmpEntry:SetQty(qty-skipQty)
--		tmpEntry:SetTotalQty(tmpEntry:GetTotalQty()-oldQty+qty-skipQty)
	end
end

-- Shared Storage
sharedStorage=localPlayer:GetSharedStorage();
function sharedStorageQuantityChanged(sender,args)
	if Settings.debug then
		Turbine.Shell.WriteLine("sharedStorageQuantityChanged")
		Turbine.Shell.WriteLine("sender:"..tostring(sender))
	end
	local name=sender:GetItemInfo():GetName();
	local qty=sender:GetQuantity();
	local index;
	local oldqty

	-- scan the shared storage, recalc the total for this name and then update accountItemQty
	local total=0;
	for index=1,sharedStorage:GetCount() do
		local item=sharedStorage:GetItem(index);
		if item~=nil and item:GetItemInfo():GetName()==name then
			total=total+item:GetQuantity();
		end
	end
	local oldTotal=accountItemQty[name]["Shared Storage"];
	accountItemQty[name].Total=accountItemQty[name].Total+total-oldTotal;
	accountItemQty[name]["Shared Storage"]=total;
	updateQuantity(name);
end
sharedStorageImage={};
function refreshSharedStorage()
	if Settings.debug then
		Turbine.Shell.WriteLine("refreshSharedStorage")
	end
	if sharedStorage:IsAvailable() then
		-- clear out any accountItemQty record for "Shared Storage" and recalc the total for any item that had a "Shared Storage" qty

		for k,v in pairs(sharedStorageImage) do
			if v.Item~=nil then
				-- safely remove old callbacks
				if v.Item.QuantityChanged~=nil then
					RemoveCallback(v.Item,"QuantityChanged",sharedStorageQuantityChanged);
				end
			end
		end
		sharedStorageImage={};
		for k,v in pairs(accountItemQty) do
			local total=0;
			for name,qty in pairs(v) do
				if name~="Total" then
					if name=="Shared Storage" then
						v[name]=nil;
					else
						total=total+qty;
					end
				end
			end
			if total==0 then
				accountItemQty[k]=nil;
			else
				v.Total=total;
			end
		end
		-- process the current Shared Storage, adding an accountItemQty record and updating total
		local size=sharedStorage:GetCount();

		local tmpIndex,tmpItem;
		for tmpIndex=1,size do
			tmpItem=sharedStorage:GetItem(tmpIndex);
			sharedStorageImage[tmpIndex]={}
			sharedStorageImage[tmpIndex].Item=tmpItem;
			if tmpItem~=nil then
				local name=tmpItem:GetItemInfo():GetName();
				local qty=tmpItem:GetQuantity();
				sharedStorageImage[tmpIndex].Index=tmpIndex;
				AddCallback(sharedStorageImage[tmpIndex].Item,"QuantityChanged",sharedStorageQuantityChanged);
				sharedStorageImage[tmpIndex].ItemName=name;
				if accountItemQty[name]==nil then
					accountItemQty[name]={}
					accountItemQty[name].Total=0;
				end
				if accountItemQty[name]["Shared Storage"]==nil then
					accountItemQty[name]["Shared Storage"]=qty;
				else
					accountItemQty[name]["Shared Storage"]=accountItemQty[name]["Shared Storage"]+qty;
				end
				accountItemQty[name].Total=accountItemQty[name].Total+qty;
			end
		end
		

		-- now refresh all of the tracking entries

		for k,v in pairs(trackEntry) do
			v:SetQty(v:GetQty());
		end
	end
end
AddCallback(sharedStorage,"IsAvailableChanged",refreshSharedStorage);
AddCallback(sharedStorage,"ItemsRefreshed",refreshSharedStorage);
sharedStorageItemAdded=function(sender,args)
	-- Index, Item
	if Settings.debug then
		Turbine.Shell.WriteLine("sharedStorageItemAdded");
	end
	local index=args.Index;
	local item=args.Item;
	table.insert(sharedStorageImage,index,{});
--
	sharedStorageImage[index].Item=item;
	if item~=nil then
		local name=item:GetItemInfo():GetName();
		local qty=item:GetQuantity();
		sharedStorageImage[index].Index=tmpIndex;
		AddCallback(sharedStorageImage[index].Item,"QuantityChanged",sharedStorageQuantityChanged);
		sharedStorageImage[index].ItemName=name;
		if accountItemQty[name]==nil then
			accountItemQty[name]={}
			accountItemQty[name].Total=0;
		end
		if accountItemQty[name]["Shared Storage"]==nil then
			accountItemQty[name]["Shared Storage"]=qty;
		else
			accountItemQty[name]["Shared Storage"]=accountItemQty[name]["Shared Storage"]+qty;
		end
		accountItemQty[name].Total=accountItemQty[name].Total+qty;
		updateQuantity(name);
	end
end
sharedStorageItemRemoved=function(sender,args)
-- Index, Item
	if Settings.debug then
		Turbine.Shell.WriteLine("sharedStorageItemRemoved");
	end
	local index=args.Index;
	local name=args.Item:GetItemInfo():GetName();
	local item=args.Item;
	local qty=0;
	if item~=nil then
		qty=item:GetQuantity();
		if item.QuantityChanged~=nil then
			RemoveCallback(item,"QuantityChanged",sharedStorageQuantityChanged);
		end
	end
	table.remove(sharedStorageImage,index);
	local accountItem=accountItemQty[name];
	if accountItem~=nil then
		accountItem.Total=accountItem.Total-qty;
		if accountItem["Shared Storage"]~=nil then
			qty=accountItem["Shared Storage"]-qty
			if qty==0 then
				accountItem["Shared Storage"]=nil
			else
				accountItem["Shared Storage"]=qty
			end
		end
	end
	updateQuantity(name);
end
AddCallback(sharedStorage,"ItemAdded",sharedStorageItemAdded);
AddCallback(sharedStorage,"ItemRemoved",sharedStorageItemRemoved);

-- Vault
vault=localPlayer:GetVault();
function vaultQuantityChanged(sender,args)
	if Settings.debug then
		Turbine.Shell.WriteLine("vaultQuantityChanged")
		Turbine.Shell.WriteLine("sender:"..tostring(sender))
	end
	local name=sender:GetItemInfo():GetName();
	local qty=sender:GetQuantity();
	local index;
	local oldqty

	-- scan the shared storage, recalc the total for this name and then update accountItemQty
	local total=0;
	for index=1,vault:GetCount() do
		local item=vault:GetItem(index);
		if item~=nil and item:GetItemInfo():GetName()==name then
			total=total+item:GetQuantity();
		end
	end
	local oldTotal=accountItemQty[name][charVaultName];
	accountItemQty[name].Total=accountItemQty[name].Total+total-oldTotal;
	accountItemQty[name][charVaultName]=total;
	updateQuantity(name);
end
vaultImage={};
function refreshVault()
	if Settings.debug then
		Turbine.Shell.WriteLine("refreshVault")
	end
	if vault:IsAvailable() then
		-- clear out any accountItemQty record for "Shared Storage" and recalc the total for any item that had a "Shared Storage" qty

		for k,v in pairs(vaultImage) do
			if v.Item~=nil then
				-- safely remove old callbacks
				if v.Item.QuantityChanged~=nil then
					RemoveCallback(v.Item,"QuantityChanged",vaultQuantityChanged);
				end
			end
		end
		vaultImage={};
		for k,v in pairs(accountItemQty) do
			local total=0;
			for name,qty in pairs(v) do
				if name~="Total" then
					if name==charVaultName then
						v[name]=nil;
					else
						total=total+qty;
					end
				end
			end
			if total==0 then
				accountItemQty[k]=nil;
			else
				v.Total=total;
			end
		end
		-- process the current Shared Storage, adding an accountItemQty record and updating total
		local size=vault:GetCount();

		local tmpIndex,tmpItem;
		for tmpIndex=1,size do
			tmpItem=vault:GetItem(tmpIndex);
			vaultImage[tmpIndex]={}
			vaultImage[tmpIndex].Item=tmpItem;
			if tmpItem~=nil then
				local name=tmpItem:GetItemInfo():GetName();
				local qty=tmpItem:GetQuantity();
				vaultImage[tmpIndex].Index=tmpIndex;
				AddCallback(vaultImage[tmpIndex].Item,"QuantityChanged",vaultQuantityChanged);
				vaultImage[tmpIndex].ItemName=name;
				if accountItemQty[name]==nil then
					accountItemQty[name]={}
					accountItemQty[name].Total=0;
				end
				if accountItemQty[name][charVaultName]==nil then
					accountItemQty[name][charVaultName]=qty;
				else
					accountItemQty[name][charVaultName]=accountItemQty[name][charVaultName]+qty;
				end
				accountItemQty[name].Total=accountItemQty[name].Total+qty;
			end
		end
		

		-- now refresh all of the tracking entries

		for k,v in pairs(trackEntry) do
			v:SetQty(v:GetQty());
		end
	end
end
AddCallback(vault,"IsAvailableChanged",refreshVault);
AddCallback(vault,"ItemsRefreshed",refreshVault);
vaultItemAdded=function(sender,args)
	-- Index, Item
	if Settings.debug then
		Turbine.Shell.WriteLine("vaultItemAdded");
	end
	local index=args.Index;
	local item=args.Item;
	table.insert(vaultImage,index,{});
--
	vaultImage[index].Item=item;
	if item~=nil then
		local name=item:GetItemInfo():GetName();
		local qty=item:GetQuantity();
		vaultImage[index].Index=tmpIndex;
		AddCallback(vaultImage[index].Item,"QuantityChanged",vaultQuantityChanged);
		vaultImage[index].ItemName=name;
		if accountItemQty[name]==nil then
			accountItemQty[name]={}
			accountItemQty[name].Total=0;
		end
		if accountItemQty[name][charVaultName]==nil then
			accountItemQty[name][charVaultName]=qty;
		else
			accountItemQty[name][charVaultName]=accountItemQty[name][charVaultName]+qty;
		end
		accountItemQty[name].Total=accountItemQty[name].Total+qty;
		updateQuantity(name);
	end
end
vaultItemRemoved=function(sender,args)
-- Index, Item
	if Settings.debug then
		Turbine.Shell.WriteLine("vaultItemRemoved");
	end
	local index=args.Index;
	local name=args.Item:GetItemInfo():GetName();
	local item=args.Item;
	local qty=0;
	if item~=nil then
		qty=item:GetQuantity();
		if item.QuantityChanged~=nil then
			RemoveCallback(item,"QuantityChanged",vaultQuantityChanged);
		end
	end
	table.remove(vaultImage,index);
	local accountItem=accountItemQty[name];
	if accountItem~=nil then
		accountItem.Total=accountItem.Total-qty;
		if accountItem[charVaultName]~=nil then
			qty=accountItem[charVaultName]-qty
			if qty==0 then
				accountItem[charVaultName]=nil
			else
				accountItem[charVaultName]=qty
			end
		end
	end
	updateQuantity(name);
end
AddCallback(vault,"ItemAdded",vaultItemAdded);
AddCallback(vault,"ItemRemoved",vaultItemRemoved);

function refreshBackPackImage()
	if Settings.debug then
		Turbine.Shell.WriteLine("refreshBackPackImage")
	end
	local index
	for index=1,backPack:GetSize() do
		if backpackImage[index]~=nil and backpackImage[index].Item~=nil then
			-- safely remove old callbacks
			if backpackImage[index].Item.QuantityChanged~=nil then
				RemoveCallback(backpackImage[index].Item,"QuantityChanged",quantityChanged)
			end
		end
		backpackImage[index]={};
		backpackImage[index].Item=backPack:GetItem(index);
		if backpackImage[index].Item~=nil then
			backpackImage[index].Index=index;
			AddCallback(backpackImage[index].Item,"QuantityChanged",quantityChanged);
			backpackImage[index].ItemName=backpackImage[index].Item:GetItemInfo():GetName();
		end
	end
end
refreshBackPackImage()
itemAdded=function(sender,args)
	if Settings.debug then
		Turbine.Shell.WriteLine("itemAdded")
	end
	-- Index, Item
	local index=args.Index;
	if backpackImage[index]~=nil and backpackImage[index].Item~=nil then
		-- safely remove old callbacks
		if backpackImage[index].Item.QuantityChanged~=nil then
			RemoveCallback(backpackImage[index].Item,"QuantityChanged",quantityChanged)
		end
		backpackImage[index].ItemName=nil;
		backpackImage[index].Item=nil;
		backpackImage[index].Index=nil;
		backpackImage[index]=nil;
	end
	backpackImage[index]={};
	backpackImage[index].Item=backPack:GetItem(index);
	if backpackImage[index].Item~=nil then
		backpackImage[index].Index=index;
		AddCallback(backpackImage[index].Item,"QuantityChanged",quantityChanged)
		-- we need to track the item name for itemRemoved events
		backpackImage[index].ItemName=backpackImage[index].Item:GetItemInfo():GetName()
		updateQuantity(backpackImage[index].ItemName)
	end
end
itemRemoved=function(sender,args)
	if Settings.debug then
		Turbine.Shell.WriteLine("itemRemoved")
	end
	-- Index
	local index=args.Index;
	if backpackImage[index]~=nil and backpackImage[index].Item~=nil then
		-- safely remove old callbacks
		if backpackImage[index].Item.QuantityChanged~=nil then
			RemoveCallback(backpackImage[index].Item,"QuantityChanged",quantityChanged)
		end
		local itemName=backpackImage[index].ItemName;
		updateQuantity(itemName,index);
		backpackImage[index].ItemName=nil;
		backpackImage[index].Item=nil;
		backpackImage[index].Index=nil;
		backpackImage[index]=nil;
	end
end
itemMoved=function(sender,args)
	if Settings.debug then
		Turbine.Shell.WriteLine("itemMoved")
	end
	-- Item, NewIndex, OldIndex
	local newIndex=args.NewIndex
	local oldIndex=args.OldIndex
	if backpackImage[oldIndex]~=nil and backpackImage[oldIndex].Item~=nil then
		-- safely remove old callbacks
		if backpackImage[oldIndex].Item.QuantityChanged~=nil then
			RemoveCallback(backpackImage[oldIndex].Item,"QuantityChanged",quantityChanged)
		end
		local itemName=backpackImage[oldIndex].ItemName;
		backpackImage[oldIndex].ItemName=nil;
		backpackImage[oldIndex].Item=nil;
		backpackImage[oldIndex].Index=nil;
		backpackImage[oldIndex]=nil;
	end
	if backpackImage[newIndex]~=nil and backpackImage[newIndex].Item~=nil then
		-- safely remove old callbacks
		if backpackImage[newIndex].Item.QuantityChanged~=nil then
			RemoveCallback(backpackImage[newIndex].Item,"QuantityChanged",quantityChanged)
		end
		local itemName=backpackImage[newIndex].ItemName;
		backpackImage[newIndex].ItemName=nil;
		backpackImage[newIndex].Item=nil;
		backpackImage[newIndex].Index=nil;
		backpackImage[newIndex]=nil;
	end

	backpackImage[oldIndex]={};
	backpackImage[oldIndex].Item=backPack:GetItem(oldIndex);
	if backpackImage[oldIndex].Item~=nil then
		backpackImage[oldIndex].Index=oldIndex;
		AddCallback(backpackImage[oldIndex].Item,"QuantityChanged",quantityChanged)
		backpackImage[oldIndex].ItemName=backpackImage[oldIndex].Item:GetItemInfo():GetName()
		updateQuantity(backpackImage[oldIndex].ItemName)
	end
	backpackImage[newIndex]={}
	backpackImage[newIndex].Item=backPack:GetItem(newIndex);
	if backpackImage[newIndex].Item~=nil then
		backpackImage[newIndex].Index=newIndex;
		AddCallback(backpackImage[newIndex].Item,"QuantityChanged",quantityChanged)
		backpackImage[newIndex].ItemName=backpackImage[newIndex].Item:GetItemInfo():GetName()
		updateQuantity(backpackImage[newIndex].ItemName)
	end
end
AddCallback(backPack,"ItemAdded",itemAdded)
AddCallback(backPack,"ItemRemoved",itemRemoved)
AddCallback(backPack,"ItemMoved",itemMoved)
setupWindow.ListSel:AddItem(Resource[language][18],0)
accountItemQty=PatchDataLoad(Turbine.DataScope.Server, "ItemTrackerData");
TrackedItemData=PatchDataLoad(Turbine.DataScope.Character, "ItemTrackerData");

function LoadData()
	if accountItemQty==nil then accountItemQty={} end
	-- remove any data from current character bags
	for k,v in pairs(accountItemQty) do
		local qty=v[charName];
		local total=0;
		if qty~=nil then
			accountItemQty[k][charName]=nil;
		end
		for name,qty in pairs(v) do
			if name~="Total" and name~=charName then
				total=total+qty;
			end
		end
		accountItemQty[k].Total=total;
		if accountItemQty[k].Total==0 then
			accountItemQty[k]=nil;
		end
	end

	if TrackedItemData~=nil then
		for k,v in ipairs(TrackedItemData) do
			trackWindows[k]=TrackWindow();
			trackWindows[k].Name=v.Name;
			trackWindows[k]:SetTop(v.Top);
			trackWindows[k]:SetLeft(v.Left);
			trackWindows[k].ItemList.ShowTotals=v.ShowTotals;
			trackWindows[k].ItemList.ShowCurrent=v.ShowCurrent;
			trackWindows[k].Index=k;
			setupWindow.ListSel:AddItem(v.Name,k)
			for i,item in ipairs(v.Items) do
				local tmpItem=Turbine.UI.Lotro.Shortcut(2,item.ItemCode):GetItem();
				if tmpItem~=nil then
					local tmpItemInfo=tmpItem:GetItemInfo();
					if tmpItemInfo~=nil then
						local tmpName=tmpItemInfo:GetName();
						if tmpName~=nil then
							local tmpItemEntry=ItemEntry();
							tmpItemEntry:SetItem(item.ItemCode);
							tmpItemEntry:SetThresholds(item.Crit,item.CritShow,item.Low,item.LowShow,item.NormalShow,item.High,item.HighShow);
							tmpItemEntry:SetParent(trackWindows[k].ItemList);
							tmpItemEntry.Group=k;
							trackWindows[k].ItemList:AddItem(tmpItemEntry);
							tmpItemEntry.Index=trackWindows[k].ItemList:GetItemCount();
							updateQuantity(tmpName);
						end
					end
				end
			end
		end
		TrackedItemData=nil;
	end
end
detailMenu=Turbine.UI.ContextMenu()
if sharedStorage:IsAvailable() then
	refreshSharedStorage()
end
if vault:IsAvailable() then
	refreshVault()
end

